create or replace package UDO_PKG_EQUIPDS_DATAPROCESS
is
/*
  :  /      /.
  :    8       
  : -
  :  ..
    : 15.02.2025
*/

  /*  -    */
  SDEF_EVENTTYPE_E0            constant PKG_STD.tSTRING := 'E0';       --     (    )
  SDEF_EVENTTYPE_EOS           constant PKG_STD.tSTRING := 'EOS';     --           ( i-   )
  SDEF_EVENTTYPE_ENOS          constant PKG_STD.tSTRING := 'ENOS';    --           ( i-   )
  SDEF_EVENTTYPE_ETMS          constant PKG_STD.tSTRING := 'ETMS';    --     
  SDEF_EVENTTYPE_ERMS          constant PKG_STD.tSTRING := 'ERMS';    --     
  SDEF_EVENTTYPE_EF            constant PKG_STD.tSTRING := 'EF';      --   i-     j-  , ..     
  SDEF_EVENTTYPE_EOL           constant PKG_STD.tSTRING := 'EOL';     --   i-       j-   ()

  /*  -    -   !!!*/
  SCOL_TYP_DF                          constant PKG_STD.tSTRING := 'null_0';
  SCOL_TYP_PARAM_HARDWARE              constant PKG_STD.tSTRING := ' ';     --   
  SCOL_TYP_CONDITIONS                  constant PKG_STD.tSTRING := ' ';        --  
  SCOL_TYP_HLSTATETYPES                constant PKG_STD.tSTRING := '  '; --   
  /*  -    -   !!!!*/
  NCOL_TYP_DF                          constant PKG_STD.tNUMBER := -1;
  NCOL_TYP_PARAM_HARDWARE              constant PKG_STD.tNUMBER := 0;   --   
  NCOL_TYP_CONDITIONS                  constant PKG_STD.tNUMBER := 1;   --  
  NCOL_TYP_HLSTATETYPES                constant PKG_STD.tNUMBER := 2;   --   

  /*  -    */
  SCOL_TYP_STRING                      constant PKG_STD.tSTRING := 'string';        --  
  SCOL_TYP_DATATIME                    constant PKG_STD.tSTRING := 'datetime';      --   
  /*  -    */
  NCOL_TYP_STRING                      constant PKG_STD.tNUMBER := 3;    --   
  NCOL_TYP_DATATIME                    constant PKG_STD.tNUMBER := 4;    --    



  /*    -         */
  type TCOL_TYP_VAL is record
  (
    SINDEX           PKG_STD.TSTRING,   --  
    SCOL_CODE        PKG_STD.TSTRING,   -- 
    SCOL_NAME        PKG_STD.TSTRING,   -- 
    SCOL_VAL         PKG_STD.TSTRING,   -- 
    NCOL_TYP         PKG_STD.tNUMBER,   --  
    SCOL_TYP         PKG_STD.TSTRING    --  
  );

  /*   -          */
  type TCOL_TYP_VALS is table of TCOL_TYP_VAL; --index by PKG_STD.TSTRING;

  /* DataSet -   c     */
  type TDATASET_VAL is record
  (
    NEQOBJKIND       PKG_STD.tREF,      --  
    NUNIT            PKG_STD.tREF,      --  
    DDATATIME        DATE,         --  
    TCOLTYP_VAL      TCOL_TYP_VALS,     --   
    SEVENTTYPE       PKG_STD.TSTRING    -- 
  );

  /* DataSet  -    c     */
  type TDATASET_VALS is table of TDATASET_VAL;
  
  /*         */
  function GET_FILENAME
  (
    SPATH            IN VARCHAR2        --    
  )RETURN            varchar2;          --    

  /*        */
  procedure DATASET_CONF_SET
  (
    NCOMPANY                  in number,              --   
    NEQUIPDSCM                in number default null, -- .      (null -     )
    NEQCONFIG                 in number default null, -- .    (null -  )
    DBEG                      in date,                --  
    DEND                      in date,                --  
    NLENGTH_GB                in number default null, --      
    NDATASET_IDENT            out number,             --   
    NDATASET_CONFIG_IDENT     out number              --      )
  );
  
  /*            FTP, SCP */
  procedure UPLOAD
  (
    NCOMPANY         in number,         -- 
    NIDENT           in number,         --  Selectlis 
    NEQUIPDSCM      in number          -- .     
  );
  
  /*             */
  procedure SEND_MD
  (
    NCOMPANY         in number,         -- 
    NIDENT           in number,         --  Selectlis 
    NEQUIPDSCM       in number          --       
  );  

  /*                */
  procedure SEND_RQ
  (
    NCOMPANY         in number,         -- 
    NEQUIPDSCMML     in number          --  .     
  );


end UDO_PKG_EQUIPDS_DATAPROCESS;
/
create or replace package body UDO_PKG_EQUIPDS_DATAPROCESS
is

  /*         */
  function GET_FILENAME
  (
    SPATH            IN VARCHAR2        --    
  )RETURN            varchar2           --    
  IS
    SFILE            PKG_STD.tSTRING;   --         
  BEGIN

   /* Parse string for UNIX system */
   IF INSTR(SPATH,'/') > 0 THEN
      SFILE := SUBSTR(SPATH,(INSTR(SPATH,'/',-1,1)+1),length(SPATH));

   /* Parse string for Windows system */
   ELSIF INSTR(SPATH,'\') > 0 THEN
      SFILE := SUBSTR(SPATH,(INSTR(SPATH,'\',-1,1)+1),length(SPATH));
  ELSE
      SFILE := SPATH;

   END IF;

   RETURN SFILE;
  END GET_FILENAME;

  /*    */
  function TCOL_TYP_VAL_MAKE
  (
    SINDEX           in varchar2,       --  
    SCOL_CODE        in varchar2,       -- 
    SCOL_NAME        in varchar2,       -- 
    SCOL_VAL         in varchar2,       -- 
    NCOL_TYP         in number,         --  
    SCOL_TYP         in varchar2        --  
  ) return           TCOL_TYP_VAL       --  
  is
    RRES             TCOL_TYP_VAL;      --   
  begin
    /*   */
    RRES.SINDEX    := SINDEX;
    RRES.SCOL_CODE := SCOL_CODE;
    RRES.SCOL_NAME := SCOL_NAME;
    RRES.SCOL_VAL  := SCOL_VAL;
    RRES.NCOL_TYP  := NCOL_TYP;
    RRES.SCOL_TYP  := SCOL_TYP;
    /*   */
    return RRES;
  end TCOL_TYP_VAL_MAKE;

  /*       */
  procedure TCOL_TYP_VALS_ADD
  (
    RCOL_TYP_VALS    in out nocopy TCOL_TYP_VALS,  --  
    SINDEX           in varchar2,                  --  
    SCOL_CODE        in varchar2,                  -- 
    SCOL_NAME        in varchar2,                  -- 
    SCOL_VAL         in varchar2,                  -- 
    NCOL_TYP         in number,                    --  
    SCOL_TYP         in varchar2                   --  
  )
  is
  begin
    /*     */
    if (RCOL_TYP_VALS is null) then
      RCOL_TYP_VALS := TCOL_TYP_VALS();
    end if;
    /*   */
    RCOL_TYP_VALS.EXTEND();
    RCOL_TYP_VALS(RCOL_TYP_VALS.LAST) := TCOL_TYP_VAL_MAKE(SINDEX => SINDEX, SCOL_CODE => SCOL_CODE, SCOL_NAME => SCOL_NAME, SCOL_VAL => SCOL_VAL, NCOL_TYP => NCOL_TYP, SCOL_TYP => SCOL_TYP);   
  
  end TCOL_TYP_VALS_ADD;

  /*   ( ) */
  function RCOL_TYP_VALS_FIND_CODE
  (
    RCOL_TYP_VALS    in out nocopy TCOL_TYP_VALS,  --  
    SCOL_NAME        in varchar2                   -- 
  ) return           PKG_STD.tSTRING               --       (null -    )
  is
  begin
    if ((RCOL_TYP_VALS is not null) and (RCOL_TYP_VALS.COUNT > 0)) then
      for I in RCOL_TYP_VALS.FIRST .. RCOL_TYP_VALS.LAST
      loop
        if (RCOL_TYP_VALS(I).SCOL_NAME = SCOL_NAME) then
          return RCOL_TYP_VALS(I).SCOL_CODE;
        end if;
      end loop;
    end if;
    /*    */
    return null;
  end RCOL_TYP_VALS_FIND_CODE;
 
  /*    Data_config - XML */
  procedure TCOL_TYP_VALS_TO_XML
  (
    RCOL_TYP_VALS    in out nocopy TCOL_TYP_VALS, --  
    CDATA_CONFIG     out clob                     --   
  )
  is
    XDOC             integer;                     --    XML-  
    XITEMATRIBS      PKG_XMAKE.tATTRIBUTES;       --   DATA_CONFIG
    XDCONFIG         PKG_XMAKE.TNODE;             --  DATA_CONFIG  
    ST1 pkg_std.tSTRING;
    ST2 pkg_std.tSTRING;
    
  begin
    /*     */
    if (/*(RCOL_TYP_VALS is not null)*/ (RCOL_TYP_VALS.COUNT > 0)) then
      /*   */
      XDOC := PKG_XMAKE.OPEN_CURSOR();
      /*    */
      for I in RCOL_TYP_VALS.FIRST .. RCOL_TYP_VALS.LAST loop
       if  RCOL_TYP_VALS(i).SINDEX != 'DATA_CONFIG' then
         continue;
       end if;  
       ST1 := RCOL_TYP_VALS(i).SCOL_NAME;
       ST2 := RCOL_TYP_VALS(i).SCOL_TYP;
        XITEMATRIBS := PKG_XMAKE.ATTRIBUTES(iCURSOR => XDOC,
                                            rATTRIBUTE00 => PKG_XMAKE.ATTRIBUTE(iCURSOR => XDOC,
                                                                                sNAME   => 'col_code', 
                                                                                sVALUE  => RCOL_TYP_VALS(i).SCOL_CODE),
                                            rATTRIBUTE01 => PKG_XMAKE.ATTRIBUTE(iCURSOR => XDOC,
                                                                                sNAME   => 'col_name', 
                                                                                sVALUE  => RCOL_TYP_VALS(i).SCOL_NAME),
                                            rATTRIBUTE02 => PKG_XMAKE.ATTRIBUTE(iCURSOR => XDOC,
                                                                                sNAME   => 'data_type', 
                                                                                sVALUE  => RCOL_TYP_VALS(i).SCOL_TYP));                
                
        XDCONFIG := PKG_XMAKE.CONCAT(ICURSOR => XDOC, 
                                     RNODE00 => XDCONFIG,
                                     rNODE01 => PKG_XMAKE.ELEMENT(ICURSOR   => XDOC,
                                                                  SNAME       => 'item',
                                                                  rATTRIBUTES => XITEMATRIBS)
                                     );             
      end loop;
      CDATA_CONFIG := PKG_XMAKE.SERIALIZE_TO_CLOB(iCURSOR => XDOC,
                                                  iTYPE   => PKG_XMAKE.DOCUMENT_,
                                                  rNODE   => PKG_XMAKE.CONCAT(iCURSOR => XDOC,
                                                                              rNODE00 => PKG_XMAKE.ELEMENT(iCURSOR => XDOC,
                                                                                                           sNAME   => 'data_config',
                                                                                                           rNODE00 => XDCONFIG)),
                                                  rHEADER => PKG_XHEADER.WRAP_ALL(sVERSION    => PKG_XHEADER.VERSION_1_0_,
                                                                                  sENCODING   => PKG_XHEADER.ENCODING_UTF_,
                                                                                  sSTANDALONE => PKG_XHEADER.STANDALONE_NONE_));
    
    PKG_XMAKE.CLOSE_CURSOR(ICURSOR => XDOC);
    end if;
  end TCOL_TYP_VALS_TO_XML;

  /*   */
  function TDATASET_VAL_MAKE
  (
    NEQOBJKIND       in number,          --  
    NUNIT            in number,          --  
    DDATATIME        in TIMESTAMP,       --  
    TCOLTYP_VAL      in out nocopy TCOL_TYP_VALS,       --   
    SEVENTTYPE       in varchar2         -- 
   ) return           TDATASET_VAL       --  
  is
    RRES             TDATASET_VAL;      --   
  begin
    /*   */
    RRES.NEQOBJKIND := NEQOBJKIND;
    RRES.NUNIT      := NUNIT;
    RRES.DDATATIME  := DDATATIME;
    RRES.TCOLTYP_VAL := TCOLTYP_VAL;
    RRES.SEVENTTYPE := SEVENTTYPE;
    /*   */
    return RRES;
  end TDATASET_VAL_MAKE;

  /*      */
  procedure TDATASET_VAL_ADD
  (
    RDATASET_VALS    in out nocopy TDATASET_VALS, --  
    NEQOBJKIND       in number,          --  
    NUNIT            in number,          --  
    DDATATIME        TIMESTAMP,          --  
    TCOLTYP_VAL      in out nocopy TCOL_TYP_VALS,       --   
    SEVENTTYPE       in varchar2         -- 
  )
  is
  begin
    /*     */
    if (RDATASET_VALS is null) then
      RDATASET_VALS := TDATASET_VALS();
    end if;
    /*   */
    RDATASET_VALS.EXTEND();
    RDATASET_VALS(RDATASET_VALS.LAST) := TDATASET_VAL_MAKE(NEQOBJKIND  => NEQOBJKIND, 
                                                           NUNIT       => NUNIT, 
                                                           DDATATIME   => DDATATIME, 
                                                           TCOLTYP_VAL => TCOLTYP_VAL,
                                                           SEVENTTYPE  => SEVENTTYPE
                                                           );
  end TDATASET_VAL_ADD;

  /*  dataset   XML */
  procedure TDATASET_VALS_TO_XML
  (
    RDATASET_VALS    in out nocopy TDATASET_VALS, --  
    CDATA_SET        out clob                     --   
  )
  is
    XDOC             integer;                     --    XML-  
    XDCOL            PKG_XMAKE.TNODE;             --
    XDCONFIG         PKG_XMAKE.TNODE;             --  DATA_CONFIG  
    S1               PKG_STD.TSTRING;             --   
    s2               PKG_STD.TSTRING;             --
  begin
    /*     */
    if ((RDATASET_VALS is not null) and (RDATASET_VALS.COUNT > 0)) then
      /*   */
      XDOC := PKG_XMAKE.OPEN_CURSOR();
      /*    */
      for I in RDATASET_VALS.FIRST .. RDATASET_VALS.LAST loop
        if ((RDATASET_VALS(i).TCOLTYP_VAL is not null) and (RDATASET_VALS(i).TCOLTYP_VAL.COUNT > 0)) then
          for j in RDATASET_VALS(i).TCOLTYP_VAL.FIRST .. RDATASET_VALS(i).TCOLTYP_VAL.LAST loop
               
             S1 :=  RDATASET_VALS(i).TCOLTYP_VAL(j).SINDEX; 
             S2 :=  RDATASET_VALS(I).NUNIT||'/'||DTS2S(RDATASET_VALS(I).DDATATIME);
               
          
               if  RDATASET_VALS(i).TCOLTYP_VAL(j).SINDEX != RDATASET_VALS(I).NUNIT||'/'||DTS2S(RDATASET_VALS(I).DDATATIME) then
                  continue;
               end if;  
         
         XDCOL := PKG_XMAKE.CONCAT(ICURSOR   => XDOC,
                                  rNODE00   => XDCOL,
                                  rNODE01   => PKG_XMAKE.ELEMENT(iCURSOR => XDOC,
                                                                 sNAME   => REPLACE(RDATASET_VALS(i).TCOLTYP_VAL(j).SCOL_NAME,' ','_'),
                                                                 rVALUE00 => PKG_XMAKE.VALUE(iCURSOR => XDOC,
                                                                                             sVALUE  => RDATASET_VALS(i).TCOLTYP_VAL(j).SCOL_VAL))
                                                      );
        
         end loop;
        end if;
        /*  XML-    */                
        XDCONFIG := PKG_XMAKE.CONCAT(ICURSOR => XDOC, 
                                     RNODE00 => XDCONFIG,
                                     RNODE01 => PKG_XMAKE.ELEMENT(ICURSOR => XDOC,
                                                                  SNAME   => 'item',
                                                                  /*rATTRIBUTES => XITEMATRIBS*/
                                                                  rNODE00 =>  PKG_XMAKE.ELEMENT(iCURSOR => XDOC,
                                                                                                sNAME   => 'NEQOBJKIND',
                                                                                                rVALUE00 => PKG_XMAKE.VALUE(iCURSOR => XDOC,
                                                                                                                            sVALUE  => RDATASET_VALS(I).NEQOBJKIND)),
                                                                  rNODE01 =>  PKG_XMAKE.ELEMENT(iCURSOR => XDOC,
                                                                                                sNAME   => 'NUNIT',
                                                                                                rVALUE00 => PKG_XMAKE.VALUE(iCURSOR => XDOC,
                                                                                                                            sVALUE  => RDATASET_VALS(I).NUNIT)),
                                                                  rNODE02 =>  PKG_XMAKE.ELEMENT(iCURSOR => XDOC,
                                                                                                sNAME   => 'DDATATIME',
                                                                                                rVALUE00 => PKG_XMAKE.VALUE_DZ(iCURSOR => XDOC,
                                                                                                                               DVALUE  => RDATASET_VALS(I).DDATATIME,
                                                                                                                               iFORMAT => 2)),
                                                                  rNODE03 => XDCOL,
                                                                  rNODE04 => PKG_XMAKE.ELEMENT(iCURSOR => XDOC,
                                                                                                sNAME   => 'SEVENTTYPE',
                                                                                                rVALUE00 => PKG_XMAKE.VALUE(iCURSOR => XDOC,
                                                                                                                            sVALUE  => RDATASET_VALS(I).SEVENTTYPE))));
                                                                                                                                             
      XDCOL := null;
      end loop;
      
      CDATA_SET := PKG_XMAKE.SERIALIZE_TO_CLOB(iCURSOR => XDOC,
                                                  iTYPE   => PKG_XMAKE.DOCUMENT_,
                                                  rNODE   => PKG_XMAKE.CONCAT(iCURSOR => XDOC,
                                                                              rNODE00 => PKG_XMAKE.ELEMENT(iCURSOR => XDOC,
                                                                                                           sNAME   => 'data_set',
                                                                                                           rNODE00 => XDCONFIG)),
                                                  rHEADER => PKG_XHEADER.WRAP_ALL(sVERSION    => PKG_XHEADER.VERSION_1_0_,
                                                                                  sENCODING   => PKG_XHEADER.ENCODING_UTF_,
                                                                                  sSTANDALONE => PKG_XHEADER.STANDALONE_NONE_));
    
    PKG_XMAKE.CLOSE_CURSOR(ICURSOR => XDOC);
    end if;
  end TDATASET_VALS_TO_XML;
  
  /*  dataset   CSV */ 
  procedure DATASET_SCV_MAKE
  (
    RDATACONF        in out nocopy TCOL_TYP_VALS, --    dataset 
    RDATASET_VALS    in out nocopy TDATASET_VALS, --  
    SDESCR           in varchar2,                 --     
    NLENGTH_GB       in number,                   --      
    NEQCONFIG_CNT    in number,                   --    
    NDATASET_IDENT   out number                   --   
  )
  is
    SLINE            PKG_STD.tSTRING /*:= 'unit;time;'*/;  --  
    SDATA            PKG_STD.tSTRING;                      --  
    N                PKG_STD.tNUMBER:= 0;                  --  
    NLENGTH          PKG_STD.tNUMBER;
    NLENGTH_DEF      PKG_STD.tNUMBER;-- := 1073741824; -- 1   !!! 
    NLENGTH_KOEFF    PKG_STD.tNUMBER := 1024;
    BDATA_SET        blob;                                 --     
    SFILENAME        PKG_STD.tSTRING :='DataSet_<ID>.csv';                      --  
    NF               PKG_STD.tNUMBER := 0;
    SDATA_VAL        PKG_STD.tSTRING;
    nREC             PKG_STD.tNUMBER := 0;
  begin
    /*     */
    if NVL(NLENGTH_GB, 0) != 0 then
      NLENGTH_DEF := ((((NLENGTH_GB * NLENGTH_KOEFF) * NLENGTH_KOEFF) *
                     NLENGTH_KOEFF));
    else
      NLENGTH_DEF := null;
    end if;
    /*     */
    NDATASET_IDENT := gen_ident;
    /*   */
    for I in RDATACONF.FIRST .. RDATACONF.LAST loop
      if RDATACONF(i).SINDEX != 'DATA_CONFIG' then
        continue;
      end if;
      SLINE := SLINE || RDATACONF(i).SCOL_CODE || ';';
      N     := I;
    end loop;
  
    SLINE := RTRIM(SLINE,';') /*|| 'EventType'*/ || CR();
    PKG_LOB_BUFFER.APPEND_BLOB(CLOB2BLOB(SLINE, PKG_CHARSET.CHARSET_UTF_));
    if RDATASET_VALS is not EMPTY then
      /*    */
      nREC := Round(30632 /NEQCONFIG_CNT,0);
      for J in RDATASET_VALS.FIRST .. RDATASET_VALS.LAST loop
        for r in 1 .. nREC loop
        --exit when r = nREC;

        SDATA := RDATASET_VALS(j)
                 .NUNIT || ';' ||r|| ';'; 
                 --DTS2S(RDATASET_VALS(j).DDATATIME) || ';';
        --if RDATASET_VALS(j).TCOLTYP_VAL is NOT EMPTY then
        
        --end if;
        /*   */
        if RDATACONF is not EMPTY then
          /*    */
          for I1 in RDATACONF.FIRST .. RDATACONF.LAST loop
            /*     DATA_CONFIG */
            if RDATACONF(i1).SINDEX != 'DATA_CONFIG' then
              continue;
            end if;
            /*   */
            SDATA_VAL := null;
            /*     */
            for l in RDATASET_VALS(j).TCOLTYP_VAL.FIRST .. RDATASET_VALS(j)
                                                           .TCOLTYP_VAL.LAST loop
              if RDATACONF(i1).SCOL_CODE is not null and RDATACONF(i1).SCOL_CODE not in ('unit','time')  then
                SDATA_VAL := replace(round(dbms_random.value(-100,100),2),',','.');
                exit;
              end if;
              /*      */
              /*if RDATACONF(i1)
               .SCOL_CODE = RDATASET_VALS(j).TCOLTYP_VAL(l).SCOL_CODE and RDATACONF(i1)
                 .NCOL_TYP = RDATASET_VALS(j).TCOLTYP_VAL(l).NCOL_TYP then
                \*       *\
                --SDATA_VAL := RDATASET_VALS(j).TCOLTYP_VAL(l).SCOL_VAL;
                SDATA_VAL := replace(round(dbms_random.value(-100,100),2),',','.');
                exit;
              else
                \*          *\
                continue;
                 --SDATA_VAL := replace(round(dbms_random.value(-100,100),2),',','.');
              end if;*/
            end loop;
          if SDATA_VAL is not null then
            SDATA := SDATA||SDATA_VAL || ';';
          end if;  
          end loop;
        end if;
      
        SDATA := RTRIM(SDATA,';') /*|| RDATASET_VALS(j).SEVENTTYPE || ';'*/ || CR();
      
        BDATA_SET := PKG_LOB_BUFFER.GET_BLOB(lCLEAR => false);
        NLENGTH   := dbms_lob.getlength(BDATA_SET);
        if (NLENGTH_DEF is not null and NLENGTH >= NLENGTH_DEF) then
          BDATA_SET := PKG_LOB_BUFFER.GET_BLOB(lCLEAR => true);
          NF        := NF + 1;
          P_FILE_BUFFER_INSERT(nIDENT    => NDATASET_IDENT,
                               cFILENAME => NF || '_' ||
                                            REPLACE(SFILENAME,
                                                    '<ID>',
                                                    gen_ident),
                               cDATA     => SDESCR,
                               bLOBDATA  => BDATA_SET);
        end if;
        PKG_LOB_BUFFER.APPEND_BLOB(CLOB2BLOB(SDATA,
                                             PKG_CHARSET.CHARSET_UTF_));
      end loop;
      end loop;
      BDATA_SET := PKG_LOB_BUFFER.GET_BLOB(lCLEAR => true);
      P_FILE_BUFFER_INSERT(nIDENT    => NDATASET_IDENT,
                           cFILENAME => NF || '_' ||
                                        REPLACE(SFILENAME, '<ID>', gen_ident),
                           cDATA     => SDESCR,
                           bLOBDATA  => BDATA_SET);
    end if;
  end DATASET_SCV_MAKE;
  
  /*        */
  procedure DATASET_CONF_MAKE
  (
    NCOMPANY         in number,                   --   
    NEQUIPDSCM       in number default null,      -- .      (null -     )
    NEQCONFIG        in number default null,      -- .    (null -  )
    DBEG             in date,                     --  
    DEND             in date,                     --  
    SDESCR           out varchar2,                --     
    NEQCONFIGCNT     out number,                  --   
    RDATA_CONFIG     in out nocopy TCOL_TYP_VALS, --  
    RDATASET_VALS    in out nocopy TDATASET_VALS  --   
  )
  is 
    NUNIT            PKG_STD.tREF;         --  
    --NEQOBJKIND       PKG_STD.tREF;       --  
    RCOLTYPVALS      TCOL_TYP_VALS;        --  
    DDATATIME        date;                 --  
    SEVENTTYPE       PKG_STD.TSTRING;      -- 
    SUNIT            PKG_STD.tSTRING;
    NEQCONFIG_CNT    PKG_STD.tNUMBER := 0; --    
    nPP_TC           PKG_STD.tNUMBER:= 0;  --      
    nPP_OC           PKG_STD.tNUMBER:= 0;  --      
    SCOL_CODE        PKG_STD.TSTRING;
    NEQOBJKIND_      PKG_STD.TREF;         --      
 begin
  -- NEQOBJKIND := NEQUIPDSCMN; --8358772;
   /*     -      ,     */
   if (NEQUIPDSCM is not null) then
     begin
       select T.EQOBJKIND into NEQOBJKIND_ from UDO_T_EQUIPDSCM T where T.RN = NEQUIPDSCM;
     exception
       when NO_DATA_FOUND then
         P_EXCEPTION(0, '     (RN: %s)  .', TO_CHAR(NEQUIPDSCM));
     end;
   end if;
   /*     -    ,    */
   if (NEQCONFIG is not null) then
     begin
       select T.OBJ_KIND into NEQOBJKIND_ from EQCONFIG T where T.RN = NEQCONFIG;
     exception
       when NO_DATA_FOUND then
         P_EXCEPTION(0, '   (RN: %s)  .', TO_CHAR(NEQCONFIG));
     end;
     if (NEQOBJKIND_ is null) then
       P_EXCEPTION(0, '   (RN: %s)     .', TO_CHAR(NEQCONFIG));
     end if;
   end if;
   /* ,    -  */
   if (NEQOBJKIND_ is null) then
     P_EXCEPTION(0, '     .');
   end if;
     /*      "unit"  "time" */
     /*           */
     TCOL_TYP_VALS_ADD(RCOL_TYP_VALS => RDATA_CONFIG,
                       SINDEX        => 'DATA_CONFIG',
                       SCOL_CODE     => 'unit',
                       SCOL_NAME     => ' ',
                       SCOL_VAL      => null,
                       NCOL_TYP      => NCOL_TYP_STRING,
                       SCOL_TYP      => SCOL_TYP_STRING);
     /*           */
     TCOL_TYP_VALS_ADD(RCOL_TYP_VALS => RDATA_CONFIG,
                       SINDEX        => 'DATA_CONFIG',
                       SCOL_CODE     => 'time',
                       SCOL_NAME     => 'DataTime',
                       SCOL_VAL      => null,
                       NCOL_TYP      => NCOL_TYP_DATATIME,
                       SCOL_TYP      => SCOL_TYP_DATATIME);

 
   /*   DATA_CONFIG */
   /*-------------------------------------------------------------------------------*/
   /*    (   ) */
   FOR TEQOBJKINDSM in (select T1.CODE, T1.NAME
                          from EQOBJKINDSM t, EQTECHSTPR t1 --, DICMUNTS t2 
                         where T.PRN = NEQOBJKIND_
                           and T.TCHSTPARAM = t1.rn
                           and T1.TYPE_PARAM = 0 --  0
                           and T.COMPANY = NCOMPANY
                           order by t1.name asc) loop
     nPP_TC := nPP_TC + 1;
     SCOL_CODE := 'p'||nPP_TC;
     /*           */
     TCOL_TYP_VALS_ADD(RCOL_TYP_VALS => RDATA_CONFIG,
                       SINDEX        => 'DATA_CONFIG',
                       SCOL_CODE     => SCOL_CODE,
                       SCOL_NAME     => TEQOBJKINDSM.NAME,
                       SCOL_VAL      => null,
                       NCOL_TYP      => NCOL_TYP_STRING,
                       SCOL_TYP      => SCOL_TYP_STRING);
   end loop;
   /*    (   ) */
   for TEQOBJKINDEXTPRM in (select T1.CODE, T1.NAME
                              from EQOBJKINDEXTPRM t, EQEXTENVPRM t1
                             where t.PRN = NEQOBJKIND_
                               and T.EQEXTENVPRM = T1.RN
                               and T.COMPANY = NCOMPANY
                               order by t1.name asc ) loop
     nPP_OC := nPP_OC + 1;
     SCOL_CODE := 's'||nPP_OC;
     /*           */
     TCOL_TYP_VALS_ADD(RCOL_TYP_VALS => RDATA_CONFIG,
                       SINDEX        => 'DATA_CONFIG',
                       SCOL_CODE     => SCOL_CODE,
                       SCOL_NAME     => TEQOBJKINDEXTPRM.NAME,
                       SCOL_VAL      => null,
                       NCOL_TYP      => NCOL_TYP_STRING,
                       SCOL_TYP      => SCOL_TYP_STRING);
   end loop;
   /*     */
   for THLSTATETYPES in (select t.code, T.READY_USE
                           from HLSTATETYPES T
                          where t.version =
                                f_company_to_version(nFLAG_SMART => 0,
                                                     nCOMPANY    => NCOMPANY,
                                                     sUNITCODE   => 'HaulierUnitsStateTypes')
                            and T.READY_USE != 0) loop
     
     nPP_OC := nPP_OC + 1;
     SCOL_CODE := 's'||nPP_OC;
     /*           */
     TCOL_TYP_VALS_ADD(RCOL_TYP_VALS => RDATA_CONFIG,
                       SINDEX        => 'DATA_CONFIG',
                       SCOL_CODE     => SCOL_CODE,
                       SCOL_NAME     => THLSTATETYPES.CODE,
                       SCOL_VAL      => null,
                       NCOL_TYP      => NCOL_TYP_STRING,
                       SCOL_TYP      => SCOL_TYP_STRING);
   end loop;   
   /*    ,   22,       
   - ,        */
   If nPP_OC < 22 then
     loop
       exit when nPP_OC = 22;
     nPP_OC := nPP_OC + 1;
     SCOL_CODE := 's'||nPP_OC;
     /*     "-" */
     TCOL_TYP_VALS_ADD(RCOL_TYP_VALS => RDATA_CONFIG,
                       SINDEX        => 'DATA_CONFIG',
                       SCOL_CODE     => SCOL_CODE,
                       SCOL_NAME     => '-',
                       SCOL_VAL      => null,
                       NCOL_TYP      => NCOL_TYP_STRING,
                       SCOL_TYP      => SCOL_TYP_STRING);
      end loop;
   end if;
   /*    */
   for TEQCONFIG in (select T.RN NUNIT, T.OPER_DATE
                       from EQCONFIG t
                      where T.OBJ_KIND = NEQOBJKIND_
                        and ((NEQCONFIG is null) or ((NEQCONFIG is not null) and (T.RN = NEQCONFIG)))
                        and T.OPER_DATE between DBEG and DEND
                        and T.COMPANY = NCOMPANY
                        order by t.OPER_DATE asc) loop
      NEQCONFIG_CNT := NEQCONFIG_CNT + 1;                   
     SUNIT := to_char(TEQCONFIG.NUNIT || '/' || DTS2S(TEQCONFIG.OPER_DATE));
     --  SDEF_EVENTTYPE_E0 Event 0   
     /*    */
     FOR TPARAM_HARDWARE in (select T1.CODE,
                                    T1.NAME,
                                    T2.MEAS_MNEMO,
                                    T2.MEAS_NAME,
                                    T.NOM_VALUE,
                                    T.MIN_VALUE,
                                    T.MAX_VALUE
                               from EQCONFIGSP t, EQTECHSTPR t1, DICMUNTS t2
                              where T.PRN = TEQCONFIG.NUNIT
                                and T.TCHSTPARAM = t1.rn
                                and T1.TYPE_PARAM = 0 --  
                                and T.UMEAS = t2.rn(+)
                              order by t1.name asc) loop

     SCOL_CODE := RCOL_TYP_VALS_FIND_CODE(RCOL_TYP_VALS => RDATA_CONFIG, SCOL_NAME => TPARAM_HARDWARE.NAME); 

       /*           */
       TCOL_TYP_VALS_ADD(RCOL_TYP_VALS => RCOLTYPVALS,
                         SINDEX        => SUNIT,
                         SCOL_CODE     => NVL(SCOL_CODE,'S0'),
                         SCOL_NAME     => TPARAM_HARDWARE.NAME,
                         SCOL_VAL      => TPARAM_HARDWARE.NOM_VALUE,
                         NCOL_TYP      => NCOL_TYP_STRING,
                         SCOL_TYP      => SCOL_TYP_STRING);
     
     end loop; -- TPARAM_HARDWARE   
     /*      */
     for TCONDITIONS in (select t1.code code_PRM,
                                t1.name name_PRM,
                                t2.code code_tp
                           from EQCONFEXTPRM     t,
                                EQEXTENVPRM      t1,
                                EQUIPWORKACTTYPE t2
                          where t.PRN = TEQCONFIG.NUNIT
                            and t.eqextenvprm = t1.rn
                            and t1.workacttype = t2.rn
                          order by t1.name asc) loop

     SCOL_CODE := RCOL_TYP_VALS_FIND_CODE(RCOL_TYP_VALS => RDATA_CONFIG, SCOL_NAME => TCONDITIONS.NAME_PRM); 

       /*           */
       TCOL_TYP_VALS_ADD(RCOL_TYP_VALS => RCOLTYPVALS,
                         SINDEX        => SUNIT,
                         SCOL_CODE     => NVL(SCOL_CODE,'S0'),
                         SCOL_NAME     => TCONDITIONS.NAME_PRM,
                         SCOL_VAL      => TCONDITIONS.code_tp,
                         NCOL_TYP      => NCOL_TYP_STRING,
                         SCOL_TYP      => SCOL_TYP_STRING);
     
     end loop; -- TCONDITIONS
     DDATATIME :=  /* S2ZSTAMP(PKG_XCONVERT.DZ_TO_XML(*/
      TEQCONFIG.OPER_DATE /*,2))*/
       ;
     /**/
     TDATASET_VAL_ADD(RDATASET_VALS => RDATASET_VALS,
                      NEQOBJKIND    => NEQOBJKIND_,
                      NUNIT         => TEQCONFIG.NUNIT,
                      DDATATIME     => DDATATIME,
                      TCOLTYP_VAL   => RCOLTYPVALS,
                      SEVENTTYPE    => SDEF_EVENTTYPE_E0);
     /*     */
     if RCOLTYPVALS IS NOT EMPTY then
     RCOLTYPVALS.delete;
     end if;
   
     --  SDEF_EVENTTYPE_E0, Event 0   
   
     --  SDEF_EVENTTYPE_EF Event of Failure  
     /*    -  "" */
     for TEQDAMCTRL in (select T.RN, T.CHNG_FIX_DATE
                          from EQDAMCTRL t
                         where T.EQCONFIG = TEQCONFIG.NUNIT
                           AND T.COMPANY = NCOMPANY
                           and T.EQ_FIX = 1) loop
       SUNIT := to_char(TEQCONFIG.NUNIT || '/' ||
                        DTS2S(TEQDAMCTRL.CHNG_FIX_DATE));
     
       /*    (  ) */
       for TEQDAMCTRLPRM in (select t2.code, t2.name, t.cur_val, t.max_val
                               from EQDAMCTRLPRM t,
                                    EQCONFIGSP   t1,
                                    EQTECHSTPR   t2
                              where t.PRN = TEQDAMCTRL.RN
                                and t.eqconfigsp = t1.rn
                                and t1.tchstparam = t2.rn
                                order by t2.code asc) loop

     SCOL_CODE := RCOL_TYP_VALS_FIND_CODE(RCOL_TYP_VALS => RDATA_CONFIG, SCOL_NAME => TEQDAMCTRLPRM.code); 

         /*           */
         TCOL_TYP_VALS_ADD(RCOL_TYP_VALS => RCOLTYPVALS,
                           SINDEX        => SUNIT,
                           SCOL_CODE     => NVL(SCOL_CODE,'S0'),
                           SCOL_NAME     => TEQDAMCTRLPRM.code,
                           SCOL_VAL      => TEQDAMCTRLPRM.max_val,
                           NCOL_TYP      => NCOL_TYP_STRING,
                           SCOL_TYP      => SCOL_TYP_STRING);
       end loop; -- TEQDAMCTRLPRM
     
       /*    (  ) */
       for TEQDAMCTRLEXTPRM in (select t2.code, t.value
                                  from EQDAMCTRLEXTPRM t,
                                       EQCONFEXTPRM    t1,
                                       EQEXTENVPRM     t2
                                 where t.PRN = TEQDAMCTRL.RN
                                   and T.EQCONFEXTPRM = t1.rn
                                   and T1.EQEXTENVPRM = t2.rn
                                   order by t2.code asc) loop

     SCOL_CODE := RCOL_TYP_VALS_FIND_CODE(RCOL_TYP_VALS => RDATA_CONFIG, SCOL_NAME => TEQDAMCTRLEXTPRM.code); 

         /*           */
         TCOL_TYP_VALS_ADD(RCOL_TYP_VALS => RCOLTYPVALS,
                           SINDEX        => SUNIT,
                           SCOL_CODE     => NVL(SCOL_CODE,'S0'),
                           SCOL_NAME     => TEQDAMCTRLEXTPRM.code,
                           SCOL_VAL      => TEQDAMCTRLEXTPRM.value,
                           NCOL_TYP      => NCOL_TYP_STRING,
                           SCOL_TYP      => SCOL_TYP_STRING);
       end loop;
       /**/
       DDATATIME :=  /*S2ZSTAMP(PKG_XCONVERT.DZ_TO_XML(*/
        TEQDAMCTRL.CHNG_FIX_DATE; /*,2)),*/
       TDATASET_VAL_ADD(RDATASET_VALS => RDATASET_VALS,
                        NEQOBJKIND    => NEQOBJKIND_,
                        NUNIT         => TEQCONFIG.NUNIT,
                        DDATATIME     => DDATATIME,
                        TCOLTYP_VAL   => RCOLTYPVALS,
                        SEVENTTYPE    => SDEF_EVENTTYPE_EF);
     
     end loop;
     /*     */
     if RCOLTYPVALS is not EMPTY then
     RCOLTYPVALS.delete;
     end if;
     --  SDEF_EVENTTYPE_EF Event of Failure  
   
     --  SDEF_EVENTTYPE_ENOS Event of Non-Operation of System i
     --  SDEF_EVENTTYPE_ETMS Event of Transition to Maintenance State
   
     /*   -       */
     for TEQRPSHEETS in (select T.STATE, t.datefact_beg, t.datefact_end
                           from EQRPSHEETS t
                          where t.EQCONFIG = TEQCONFIG.NUNIT) loop
       /*   */
       case TEQRPSHEETS.STATE
       /*  - ""     */
         when 3 then
           DDATATIME  :=  /*S2ZSTAMP(PKG_XCONVERT.DZ_TO_XML(*/
            TEQRPSHEETS.DATEFACT_END /*,2))*/
             ;
           SEVENTTYPE := SDEF_EVENTTYPE_ERMS;
           /*  - ""     */
         when 2 then
           DDATATIME  :=  /*S2ZSTAMP(PKG_XCONVERT.DZ_TO_XML(*/
            TEQRPSHEETS.DATEFACT_BEG /*,2))*/
             ;
           SEVENTTYPE := SDEF_EVENTTYPE_ETMS;
         else
           DDATATIME  := null;
           SEVENTTYPE := null;
       end case;
       SUNIT := TO_CHAR(TEQCONFIG.NUNIT || '/' || DTS2S(DDATATIME));
       /*  */
       if DDATATIME is not null and SEVENTTYPE is not null then
        /* TCOL_TYP_VALS_ADD(RCOL_TYP_VALS => RCOLTYPVALS,
                           SINDEX        => SUNIT,
                           SCOL_NAME     => 'null_0',
                           SCOL_VAL      => '-',
                           NCOL_TYP      => NCOL_TYP_DF,
                           SCOL_TYP      => SCOL_TYP_DF);*/
         TDATASET_VAL_ADD(RDATASET_VALS => RDATASET_VALS,
                          NEQOBJKIND    => NEQOBJKIND_,
                          NUNIT         => TEQCONFIG.NUNIT,
                          DDATATIME     => DDATATIME,
                          TCOLTYP_VAL   => RCOLTYPVALS,
                          --SCOL_NAME     => null, --     
                          --SCOL_VAL      => null, --                            
                          SEVENTTYPE => SEVENTTYPE);
         /*     */
         if RCOLTYPVALS is not EMPTY then
         RCOLTYPVALS.delete;
         end if;
       end if;
     end loop;
   
     --  SDEF_EVENTTYPE_ENOS Event of Non-Operation of System i 
     --  SDEF_EVENTTYPE_ETMS Event of Transition to Maintenance State
   
     --  SDEF_EVENTTYPE_ERMS Event of Return from Maintenance State
     --  SDEF_EVENTTYPE_EOS Event of System i
     /*   (  ) */
     for TEQCONFIGSH in (select t1.code, t1.ready_use, t.change_date
                           from EQCONFIGSH t, HLSTATETYPES t1
                          where t.PRN = TEQCONFIG.NUNIT
                            and t.hlstatetypes = t1.rn
                            order by t1.code asc) loop
       case TEQCONFIGSH.READY_USE
       /*    */
         when 2 then
           SEVENTTYPE := SDEF_EVENTTYPE_EOS;
           /*     */
         when 1 then
           SEVENTTYPE := SDEF_EVENTTYPE_ENOS;
         else
           SEVENTTYPE := null;
       end case;
       /**/
     
       if SEVENTTYPE is not null then
         DDATATIME :=  /*PKG_XCONVERT.DZ_TO_XML(*/
          TEQCONFIGSH.CHANGE_DATE; /*,2)*/
         SUNIT     := TO_CHAR(TEQCONFIG.NUNIT || '/' || DTS2S(DDATATIME));
     SCOL_CODE := RCOL_TYP_VALS_FIND_CODE(RCOL_TYP_VALS => RDATA_CONFIG, SCOL_NAME => TEQCONFIGSH.CODE); 

         TCOL_TYP_VALS_ADD(RCOL_TYP_VALS => RCOLTYPVALS,
                           SINDEX        => SUNIT,
                           SCOL_CODE     => NVL(SCOL_CODE,'S0'),
                           SCOL_NAME     => TEQCONFIGSH.CODE,
                           SCOL_VAL      => TEQCONFIGSH.READY_USE,
                           NCOL_TYP      => NCOL_TYP_STRING,
                           SCOL_TYP      => SCOL_TYP_STRING);
       
         TDATASET_VAL_ADD(RDATASET_VALS => RDATASET_VALS,
                          NEQOBJKIND    => NEQOBJKIND_,
                          NUNIT         => TEQCONFIG.NUNIT,
                          DDATATIME     => DDATATIME,
                          TCOLTYP_VAL   => RCOLTYPVALS,
                          --SCOL_NAME     => TEQCONFIGSH.CODE,        --     
                          --SCOL_VAL      => TEQCONFIGSH.READY_USE,   --                                
                          SEVENTTYPE => SEVENTTYPE);
         /*     */
         if RCOLTYPVALS is not EMPTY then
         RCOLTYPVALS.delete;
         end if;
       end if;
     
     end loop;
   
   --  SDEF_EVENTTYPE_ERMS Event of Return from Maintenance State
   --  SDEF_EVENTTYPE_EOS Event of System i
   
   --  SDEF_EVENTTYPE_EOL Event of Limit State i   
   --      -   -         " -    ,       "   "    "
   --  SDEF_EVENTTYPE_EOL Event of Limit State i  
   
   end loop; -- TEQCONFIG
   /*  */
   SDESCR := '  - '|| D2S(DBEG)||CR()
          ||'  - '||D2S(DEND)||CR()
          ||'     - '||NEQCONFIG_CNT||CR()
          ||'ID   - '||NEQOBJKIND_;
   NEQCONFIGCNT := NEQCONFIG_CNT;
 end DATASET_CONF_MAKE;
 
  /*        */
  procedure DATASET_CONF_SET
  (
    NCOMPANY                in number,              --   
    NEQUIPDSCM              in number default null, -- .      (null -     )
    NEQCONFIG               in number default null, -- .    (null -  )
    DBEG                    in date,                --  
    DEND                    in date,                --  
    NLENGTH_GB              in number default null, --      
    NDATASET_IDENT          out number,             --   
    NDATASET_CONFIG_IDENT   out number              --      )
  ) 
  is
    RDATA_CONFIG            TCOL_TYP_VALS;          --  
    RDATASET_VALS           TDATASET_VALS;          --   
    SDESCR                  PKG_STD.TSTRING;        --     
    CDATA_CONFIG            clob;                   --    
    NEQCONFIGCNT            PKG_STD.TNUMBER;        --   ,   
  begin
    /* ,        ,  .    */
    if (((NEQUIPDSCM is null) and (NEQCONFIG is null)) or ((NEQUIPDSCM is not null) and (NEQCONFIG is not null))) then
      P_EXCEPTION(0,
                  '       ,   .');
    end if;
    /*        */
    DATASET_CONF_MAKE(NCOMPANY      => NCOMPANY,
                      NEQUIPDSCM    => NEQUIPDSCM,
                      NEQCONFIG     => NEQCONFIG,
                      DBEG          => DBEG,
                      DEND          => DEND,
                      SDESCR        => SDESCR,
                      NEQCONFIGCNT  => NEQCONFIGCNT,
                      RDATA_CONFIG  => RDATA_CONFIG,
                      RDATASET_VALS => RDATASET_VALS);
    /*    Data_config - XML */
    TCOL_TYP_VALS_TO_XML(RCOL_TYP_VALS => RDATA_CONFIG, CDATA_CONFIG => CDATA_CONFIG);
    /*         */
    NDATASET_CONFIG_IDENT := GEN_IDENT();
    /*     */
    P_FILE_BUFFER_INSERT(NIDENT    => NDATASET_CONFIG_IDENT,
                         CFILENAME => 'CDATA_CONFIG',
                         CDATA     => CDATA_CONFIG,
                         BLOBDATA  => null);
    /*  dataset   CSV */
    DATASET_SCV_MAKE(RDATACONF      => RDATA_CONFIG,
                     RDATASET_VALS  => RDATASET_VALS,
                     SDESCR         => SDESCR,
                     NLENGTH_GB     => NLENGTH_GB,
                     NEQCONFIG_CNT  => NEQCONFIGCNT,
                     NDATASET_IDENT => NDATASET_IDENT);
  end DATASET_CONF_SET;

  /*            FTP, SCP */
  procedure UPLOAD
  (
    NCOMPANY         in number,         -- 
    NIDENT           in number,         --  Selectlis 
    NEQUIPDSCM       in number          -- .     
  )  
  is
    NEXSSERVICEFN    PKG_STD.tREF;      --       
    SHOST            PKG_STD.tSTRING;   -- host
    SPORT            PKG_STD.tSTRING;   -- port
    SUSER            PKG_STD.tSTRING;   -- username
    SPASS            PKG_STD.tSTRING;   -- password
    SPATCH_FSERV     PKG_STD.tSTRING;   --      CSP
  begin
   /*    -      */
   begin
     select T.EXSSERVICEFN_UPLOAD
       into NEXSSERVICEFN
       from UDO_T_EQUIPDSCM T
      where T.RN = NEQUIPDSCM;
   exception
     when NO_DATA_FOUND then
       p_exception(0,
                   '        RN "s%",  .',
                   NEQUIPDSCM);
     when TOO_MANY_ROWS then
       p_exception(0,
                   '           RN "s%".',
                   NEQUIPDSCM);
   end;
   UDO_PKG_EQUIPDS_SEND.SCP_DATA_MAKE(NEXSSERVICEFN => NEXSSERVICEFN, 
                                      SHOST         => SHOST, 
                                      SPORT         => SPORT, 
                                      SUSER         => SUSER,
                                      SPASS         => SPASS, 
                                      SPATCH_FSERV  => SPATCH_FSERV);
                                      
   for TEQUIPDSCMFL in(select E.* from UDO_T_EQUIPDSCMFL E, SELECTLIST SL where E.RN = SL.DOCUMENT and SL.IDENT = NIDENT)loop
       /*   */
       UDO_PKG_EQUIPDS_SEND.SEND_PACKGE(NEXSSERVICEFN  => NEXSSERVICEFN, 
                                        NLNK_NEXSQUEUE => null, 
                                        NCOMPANY       => NCOMPANY, 
                                        NDOCUMENT      => TEQUIPDSCMFL.RN, 
                                        SUNITCODE      => null, 
                                        SHOST          => SHOST, 
                                        SPORT          => SPORT, 
                                        SUSER          => SUSER, 
                                        SPASS          => SPASS, 
                                        --bAUTH          => true,
                                        SPATCH_LOKAL   => TEQUIPDSCMFL.FILE_NAME, 
                                        NEQUIPDSCMN    => NEQUIPDSCM,
                                        SPATCH_FSERV   => '/'||SPATCH_FSERV||'/'||TEQUIPDSCMFL.FILE_NAME, 
                                        NPRIORITY      => 0, 
                                        BMSG           => TEQUIPDSCMFL.DATASET);
   end loop;
  end UPLOAD;
  
  /*             */
  procedure SEND_MD
  (
    NCOMPANY         in number,         -- 
    NIDENT           in number,         --  Selectlis 
    NEQUIPDSCM       in number          --       
  )  
  is
    NEXSSERVICEFN    PKG_STD.tREF;      -- .   
    BXML             blob;              --   
    NDATASET_ID      PKG_STD.tREF;      -- DATASET_ID
  begin
   /*    -      */
   begin
     select T.EXSSERVICEFN_SEND_MD
       into NEXSSERVICEFN
       from UDO_T_EQUIPDSCM T
      where T.RN = NEQUIPDSCM;
   exception
     when NO_DATA_FOUND then
       p_exception(0,
                   '        RN "s%",  .',
                   NEQUIPDSCM);
     when TOO_MANY_ROWS then
       p_exception(0,
                   '           RN "s%".',
                   NEQUIPDSCM);
   end;

      /*    */
      UDO_PKG_EQUIPDS_SEND.METADATA_MAKE(NIDENT => NIDENT, NEQUIPDSCM => NEQUIPDSCM, NDATASET_ID => NDATASET_ID, BXML => BXML );
  
      /*   */
      UDO_PKG_EQUIPDS_SEND.SEND_PACKGE(NEXSSERVICEFN  => NEXSSERVICEFN, 
                                       NLNK_NEXSQUEUE => null, 
                                       NCOMPANY       => NCOMPANY, 
                                       NDOCUMENT      => NDATASET_ID, 
                                       SUNITCODE      => null,
                                       bAUTH          => true, 
                                       NPRIORITY      => 0, 
                                       BMSG           => BXML
                                       );
       
  end SEND_MD;
  
  /*                */
  procedure SEND_RQ
  (
    NCOMPANY         in number,         -- 
    NEQUIPDSCMML     in number          --  .       
  )  
  is
    NEXSSERVICEFN    PKG_STD.tREF;      -- .   
    BXML             blob;              --   
  begin
   /*    -      */
   begin
     select m.EXSSERVICEFN_SEND_RQ
       into NEXSSERVICEFN
       from UDO_T_EQUIPDSCM m, UDO_T_EQUIPDSCMML ml 
      where ml.rn = NEQUIPDSCMML
        and M.RN = ML.PRN;
   exception
     when NO_DATA_FOUND then
       p_exception(0,
                   '       RN "s%",  .',
                   NEQUIPDSCMML);
     when TOO_MANY_ROWS then
       p_exception(0,
                   '          RN "s%".',
                   NEQUIPDSCMML);
   end;

      /*    */
      UDO_PKG_EQUIPDS_SEND.REQUIREMENTS_MAKE(NEQUIPDSCMML => NEQUIPDSCMML, BXML => BXML );
  
      /*   */
      UDO_PKG_EQUIPDS_SEND.SEND_PACKGE(NEXSSERVICEFN  => NEXSSERVICEFN, 
                                       NLNK_NEXSQUEUE => null, 
                                       NCOMPANY       => NCOMPANY, 
                                       NDOCUMENT      => NEQUIPDSCMML, 
                                       SUNITCODE      => null, 
                                       bAUTH          => true,
                                       NPRIORITY      => 0, 
                                       BMSG           => BXML
                                       );
       
  end SEND_RQ;


end UDO_PKG_EQUIPDS_DATAPROCESS;
/
