create or replace package UDO_PKG_EQUIPTCF as

  /*     */
  procedure EQCONFIG_HIER
  (
    NEQPARENT               in number,  -- .     
    COUT                    out clob    --  XML- 
  );

  /*     */
  procedure EQCONFIG_THOBJ_LIST_COND;
  
  /*          */
  procedure EQCONFIG_THOBJ_LIST
  (
    NEQPARENT               in number,  -- .     
    NPAGE_NUMBER            in number,  --   (  NPAGE_SIZE=0)
    NPAGE_SIZE              in number,  --     (0 - )
    CFILTERS                in clob,    -- 
    CORDERS                 in clob,    -- 
    NINCLUDE_DEF            in number,  --       
    COUT                    out clob    --   
  );
  
  /*        */
  function EQCONFIG_THOBJ_GET_NXTEQTCHSRV
  (
    NEQCONFIG               in number,        -- .   
    NSTATE                  in number := null --  (null - )
  ) return                  date;             --    
  
  /*         */
  procedure EQCONFIG_THOBJ_SELECT_EQTCHSRV
  (
    NEQTCHSRV               in number := null, -- .      (null - )
    NEQCONFIG               in number := null, -- .    (null - )
    NSTATE                  in number := null, --  (null - )    
    NIDENT                  out number         --  
  );
  
  /*          */
  function EQCONFIG_THOBJ_GET_NXTEQRPSHT
  (
    NEQCONFIG               in number,        -- .   
    NSTATE                  in number := null --  (null - )
  ) return                  date;             --     

  /*      */
  procedure EQCONFIG_THOBJ_SELECT_EQRPSHT
  (
    NEQRPSHEETS             in number := null, -- .    (null - )
    NEQCONFIG               in number := null, -- .    (null - )
    NSTATE                  in number := null, --  (null - )
    NIDENT                  out number         --  
  );
  
  /*     */
  procedure EQCONFIG_THOBJ_CARD
  (
    NEQCONFIG               in number,  -- .   
    COUT                    out clob    --  
  );
  
  /*           */
  procedure EQCONFIG_THOBJ_FORECAST_BCLR
  (
    NDATASET_IDENT          in number,  --   
    NDATASET_CONFIG_IDENT   in number,  --    
    NREQUEST_CONFIG_IDENT   in number   --        
  );

  /*         */
  procedure EQCONFIG_THOBJ_FORECAST_PRLG
  (
    NEQUIPDSCMML            in number,    -- .  
    NDATASET_IDENT          in number,    --   
    NDATASET_CONFIG_IDENT   in number,    --    
    NREQUEST_CONFIG_IDENT   in number,    --    
    SURL                    out varchar2, --   
    SAUTH_TOKEN             out varchar2, --    
    SDATASET_ID             out varchar2, --    
    CDATASET_CONFIG         out clob,     --    
    SDATASET_URL            out varchar2, --      
    SCLASS_MACHINE          out varchar2, --     
    STASK                   out varchar2  --    (.  UDO_PKG_EQUIPDS_BASE.SCMML_TASK_*)
  );
  
  /*         */
  procedure EQCONFIG_THOBJ_FORECAST_EPLG
  (
    NDATASET_IDENT          in number,         --   
    NDATASET_CONFIG_IDENT   in number,         --    
    NREQUEST_CONFIG_IDENT   in number,         --        
    NEQCONFIG               in number := null, -- .   
    NEQUIPDSCMML            in number := null, -- .  
    CFORECAST               in clob := null    --   
  );
  
  /*       */
  function EQCONFIG_THOBJ_FORECAST_CLR
  (
    NMODE                   in number := 0, --   (0 -     , 1 -   , 2 -   
    NVALUE                  in number :=0   --   
  ) return                  varchar2;       --      
  
  /*        */
  procedure EQCONFIG_THOBJ_FORECAST_CRD
  (
    NEQCONFIG               in number,   -- .    
    DFORECAST_DATE          in date,     --   
    NFORECAST               in number,   --  ,   
    SDICMUNTS               in varchar2, --   
    STASK                   in varchar2, --  (.  UDO_PKG_EQUIPDS_BASE.CMML_TASK_*)
    COUT                    out clob     --    
  );
  
  /*          */
  procedure EQCONFIG_THOBJ_FORECAST_CRDP
  (
    CFORECAST               in clob,      --    
    SFORECAST_DESC          out varchar2, --  
    SFORECAST_DESC_COLOR    out varchar2  --   
  );

  /*              RUL- */
  function EQCONFIG_THOBJ_TCHSRV_BRKDPROB
  (
    NEQCONFIG               in number   -- .   
  ) return                  number;     --    
  
  /*         */
  procedure EQCONFIG_THOBJ_CHNG_EQTCHSRV
  (
    NEQCONFIG               in number,  -- .   
    NEQTCHSRV               in number,  -- .     
    DPLANDATE_FROM          in date     --     
  );

  /*       */
  procedure EQCONFIG_THOBJ_MAKE_EQRPSHEET
  (
    NEQCONFIG               in number,   -- .   
    SACATALOG               in varchar2, --   
    SEQTECSRVKIND           in varchar2, --  
    DPLANDATE_FROM          in date,     --    
    NIDENT                  out number   --    
  );
  
end UDO_PKG_EQUIPTCF;
/
create or replace package body UDO_PKG_EQUIPTCF as

/*
TODO: owner="root" created="02.08.2024"
text="        "
*/

  /*  -  API   */
  SFW_API_ROOT              constant PKG_STD.TSTRING := '/API'; --  API
  SFW_API_FORECAST          constant PKG_STD.TSTRING := '/forecast/metadata'; --    ( )

  /*      */
  function EQCONFIG_HIER_NODE
  (
    NCUR                    in integer,      --        
    NCOMPANY                in number,       -- .  
    NEQPARENT               in number        -- .      
  ) return                  PKG_XMAKE.TNODE  -- XML-  
  is
    XLEAF                   PKG_XMAKE.TNODE; --  
    XCHILD                  PKG_XMAKE.TNODE; --   
    XRES                    PKG_XMAKE.TNODE; --   
  begin
    /*       */
    for C in (select M.RN NRN,
                     M.EQPARENT NHRN,
                     DECODE(M.FICT_REC, 0, M.NAME, DECODE(OL.RN, null, M.NAME, OL.NAME)) SNAME,
                     case
                       when exists
                        (select null
                               from EQCONFIG C
                              where C.EQPARENT = M.RN
                                and exists (select null from V_USERPRIV_HIER_SINGL UP where UP.HIERARCHY = C.RN)) then
                        1
                       else
                        0
                     end NHASCHILDREN,
                     M.OBJ_KIND NOBJ_KIND
                from EQCONFIG   M,
                     EQOBJLEVEL OL
               where M.PR_OBJ_LEVEL = OL.RN(+)
                 and ((M.FICT_REC = 0) or ((M.FICT_REC = 1) and (CMP_VC2(M.NAME, F_EQCONFIG_EXTRANAME(0)) = 1)))
                 and exists (select null from V_USERPRIV_HIER_SINGL UP where UP.HIERARCHY = M.RN)
                 and COALESCE(M.EQPARENT, 0) = NEQPARENT
                 and M.COMPANY = NCOMPANY
               order by 3)
    loop
      /*     */
      if (C.NHASCHILDREN = 1) then
        /*           */
        XCHILD := PKG_XMAKE.ELEMENT(ICURSOR     => NCUR,
                                    SNAME       => 'children',
                                    RATTRIBUTES => PKG_XMAKE.ATTRIBUTES(ICURSOR      => NCUR,
                                                                        RATTRIBUTE00 => PKG_XMAKE.ATTRIBUTE(ICURSOR => NCUR,
                                                                                                            SNAME   => 'id',
                                                                                                            SVALUE  => C.NRN ||
                                                                                                                       '_loader'),
                                                                        RATTRIBUTE01 => PKG_XMAKE.ATTRIBUTE(ICURSOR => NCUR,
                                                                                                            SNAME   => 'label',
                                                                                                            SVALUE  => '...')));
        /*   */
        XLEAF := PKG_XMAKE.ELEMENT(ICURSOR     => NCUR,
                                   SNAME       => 'children',
                                   RATTRIBUTES => PKG_XMAKE.ATTRIBUTES(ICURSOR      => NCUR,
                                                                       RATTRIBUTE00 => PKG_XMAKE.ATTRIBUTE(ICURSOR => NCUR,
                                                                                                           SNAME   => 'id',
                                                                                                           SVALUE  => C.NRN),
                                                                       RATTRIBUTE01 => PKG_XMAKE.ATTRIBUTE(ICURSOR => NCUR,
                                                                                                           SNAME   => 'label',
                                                                                                           SVALUE  => C.SNAME)),
                                   RNODE00     => XCHILD);
        /*     */
        XRES := PKG_XMAKE.CONCAT(ICURSOR => NCUR, RNODE00 => XRES, RNODE01 => XLEAF);
      end if;
    end loop;
    /*   */
    return XRES;
  end EQCONFIG_HIER_NODE;
  
  /*     */
  procedure EQCONFIG_HIER
  (
    NEQPARENT               in number,                             -- .     
    COUT                    out clob                               --  XML- 
  )
  is    
    NCOMPANY                PKG_STD.TREF := GET_SESSION_COMPANY(); -- .  
    NCUR                    integer;                               --    
    XDOC                    PKG_XMAKE.TNODE;                       --   
  begin
    /*   */
    NCUR := PKG_XMAKE.OPEN_CURSOR();
    /*  XML-     */
    XDOC := PKG_XMAKE.ELEMENT(ICURSOR => NCUR,
                              SNAME   => 'XDATA',
                              RNODE00 => EQCONFIG_HIER_NODE(NCUR => NCUR, NCOMPANY => NCOMPANY, NEQPARENT => NEQPARENT));
    /*   CLOB */
    COUT := PKG_XMAKE.SERIALIZE_TO_CLOB(ICURSOR => NCUR,
                                        ITYPE   => PKG_XMAKE.CONTENT_,
                                        RNODE   => XDOC,
                                        RHEADER => PKG_XHEADER.WRAP_ALL(SVERSION    => PKG_XHEADER.VERSION_1_0_,
                                                                        SENCODING   => PKG_XHEADER.ENCODING_UTF_,
                                                                        SSTANDALONE => PKG_XHEADER.STANDALONE_YES_));
    /*   */
    PKG_XMAKE.CLOSE_CURSOR(ICURSOR => NCUR);
  end EQCONFIG_HIER;

  /*     */
  procedure EQCONFIG_THOBJ_LIST_COND
  is
  begin
    /*    */
    PKG_COND_BROKER.SET_TABLE(STABLE_NAME => 'EQCONFIG');
    /*  */
    PKG_COND_BROKER.ADD_CONDITION_CODE(SCOLUMN_NAME => 'CODE', SCONDITION_NAME => 'SCODEFrom');
    /*  */
    PKG_COND_BROKER.ADD_CONDITION_CODE(SCOLUMN_NAME => 'NAME', SCONDITION_NAME => 'SNAMEFrom');
    /*     */
    PKG_COND_BROKER.ADD_CONDITION_BETWEEN(SCOLUMN_NAME         => 'OPER_DATE',
                                          SCONDITION_NAME_FROM => 'DOPER_DATEFrom',
                                          SCONDITION_NAME_TO   => 'DOPER_DATETo');
    /*  */
    PKG_COND_BROKER.ADD_CONDITION_CODE(SCOLUMN_NAME    => 'CODE',
                                       SCONDITION_NAME => 'SUSE_KINDFrom',
                                       SJOINS          => 'HLSTATETYPES <- RN;HLSTATETYPES');
    /*  */
    PKG_COND_BROKER.ADD_CONDITION_CODE(SCOLUMN_NAME    => 'NAME',
                                       SCONDITION_NAME => 'SOBJ_KINDFrom',
                                       SJOINS          => 'OBJ_KIND <- RN;EQOBJKIND');
    /*     */
    if (PKG_COND_BROKER.CONDITION_EXISTS(SCONDITION_NAME => 'NCMML_STATUSFrom') = 1) then
      PKG_COND_BROKER.ADD_CLAUSE(SCLAUSE => PKG_SQL_BUILD.PKG_NAME(SNAME => 'UDO_PKG_EQUIPDS.CMML_STATUS_BY_EQCONFIG') ||
                                            '(RN) = :NCMML_STATUS');
      PKG_COND_BROKER.BIND_VARIABLE(SVARIABLE_NAME => 'NCMML_STATUS',
                                    SVALUE         => PKG_COND_BROKER.GET_CONDITION_NUM(SCONDITION_NAME => 'NCMML_STATUSFrom'));
    end if;
    /*     */
    if ((PKG_COND_BROKER.CONDITION_EXISTS(SCONDITION_NAME => 'NBREAKDOWN_PROBFrom') = 1) and
       (PKG_COND_BROKER.CONDITION_EXISTS(SCONDITION_NAME => 'NBREAKDOWN_PROBTo') = 0)) then
      PKG_COND_BROKER.ADD_CLAUSE(SCLAUSE => PKG_SQL_BUILD.PKG_NAME(SNAME => 'UDO_PKG_EQUIPTCF.EQCONFIG_THOBJ_TCHSRV_BRKDPROB') ||
                                            '(RN) >= :NBREAKDOWN_PROBFrom');
      PKG_COND_BROKER.BIND_VARIABLE(SVARIABLE_NAME => 'NBREAKDOWN_PROBFrom',
                                    NVALUE         => PKG_COND_BROKER.GET_CONDITION_NUM(SCONDITION_NAME => 'NBREAKDOWN_PROBFrom'));
    end if;
    if ((PKG_COND_BROKER.CONDITION_EXISTS(SCONDITION_NAME => 'NBREAKDOWN_PROBTo') = 1) and
       (PKG_COND_BROKER.CONDITION_EXISTS(SCONDITION_NAME => 'NBREAKDOWN_PROBFrom') = 0)) then
      PKG_COND_BROKER.ADD_CLAUSE(SCLAUSE => PKG_SQL_BUILD.PKG_NAME(SNAME => 'UDO_PKG_EQUIPTCF.EQCONFIG_THOBJ_TCHSRV_BRKDPROB') ||
                                            '(RN) <= :NBREAKDOWN_PROBTo');
      PKG_COND_BROKER.BIND_VARIABLE(SVARIABLE_NAME => 'NBREAKDOWN_PROBTo',
                                    NVALUE         => PKG_COND_BROKER.GET_CONDITION_NUM(SCONDITION_NAME => 'NBREAKDOWN_PROBTo'));
    end if;
    if ((PKG_COND_BROKER.CONDITION_EXISTS(SCONDITION_NAME => 'NBREAKDOWN_PROBFrom') = 1) and
       (PKG_COND_BROKER.CONDITION_EXISTS(SCONDITION_NAME => 'NBREAKDOWN_PROBTo') = 1)) then
      PKG_COND_BROKER.ADD_CLAUSE(SCLAUSE => PKG_SQL_BUILD.PKG_NAME(SNAME => 'UDO_PKG_EQUIPTCF.EQCONFIG_THOBJ_TCHSRV_BRKDPROB') ||
                                            '(RN) between :NBREAKDOWN_PROBFrom and :NBREAKDOWN_PROBTo');
      PKG_COND_BROKER.BIND_VARIABLE(SVARIABLE_NAME => 'NBREAKDOWN_PROBFrom',
                                    NVALUE         => PKG_COND_BROKER.GET_CONDITION_NUM(SCONDITION_NAME => 'NBREAKDOWN_PROBFrom'));
      PKG_COND_BROKER.BIND_VARIABLE(SVARIABLE_NAME => 'NBREAKDOWN_PROBTo',
                                    NVALUE         => PKG_COND_BROKER.GET_CONDITION_NUM(SCONDITION_NAME => 'NBREAKDOWN_PROBTo'));
    end if;
  end EQCONFIG_THOBJ_LIST_COND;
  
  /*          */
  procedure EQCONFIG_THOBJ_LIST
  (
    NEQPARENT               in number,                             -- .     
    NPAGE_NUMBER            in number,                             --   (  NPAGE_SIZE=0)
    NPAGE_SIZE              in number,                             --     (0 - )
    CFILTERS                in clob,                               -- 
    CORDERS                 in clob,                               -- 
    NINCLUDE_DEF            in number,                             --       
    COUT                    out clob                               --   
  )
  is
    NCOMPANY                PKG_STD.TREF := GET_SESSION_COMPANY(); --  
    NIDENT                  PKG_STD.TREF := GEN_IDENT();           --  
    RF                      PKG_P8PANELS_VISUAL.TDG_FILTERS;       -- 
    RO                      PKG_P8PANELS_VISUAL.TDG_ORDERS;        -- 
    RDG                     PKG_P8PANELS_VISUAL.TDG;               --  
    RDG_ROW                 PKG_P8PANELS_VISUAL.TDG_ROW;           --  
    RCOL_VALS               PKG_P8PANELS_VISUAL.TDG_COL_VALS;      --   
    NROW_FROM               PKG_STD.TREF;                          --   
    NROW_TO                 PKG_STD.TREF;                          --   
    CSQL                    clob;                                  --   
    ICURSOR                 integer;                               --    
    NBREAKDOWN_PROB         PKG_STD.TNUMBER;                       --          
  begin
    /*   */
    RF := PKG_P8PANELS_VISUAL.TDG_FILTERS_FROM_XML(CFILTERS => CFILTERS);
    /*   */
    RO := PKG_P8PANELS_VISUAL.TDG_ORDERS_FROM_XML(CORDERS => CORDERS);
    /*            */
    PKG_P8PANELS_VISUAL.UTL_ROWS_LIMITS_CALC(NPAGE_NUMBER => NPAGE_NUMBER,
                                             NPAGE_SIZE   => NPAGE_SIZE,
                                             NROW_FROM    => NROW_FROM,
                                             NROW_TO      => NROW_TO);
    /*    */
    RDG := PKG_P8PANELS_VISUAL.TDG_MAKE();
    /*      */
    PKG_P8PANELS_VISUAL.TDG_ADD_COL_DEF(RDATA_GRID => RDG,
                                        SNAME      => 'NRN',
                                        SCAPTION   => '. ',
                                        SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_NUMB,
                                        BVISIBLE   => false);
    PKG_P8PANELS_VISUAL.TDG_ADD_COL_DEF(RDATA_GRID => RDG,
                                        SNAME      => 'SCODE',
                                        SCAPTION   => '',
                                        SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR,
                                        BORDER     => true,
                                        BFILTER    => true);
    PKG_P8PANELS_VISUAL.TDG_ADD_COL_DEF(RDATA_GRID => RDG,
                                        SNAME      => 'SNAME',
                                        SCAPTION   => '',
                                        SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR,
                                        BORDER     => true,
                                        BFILTER    => true);
    PKG_P8PANELS_VISUAL.TDG_ADD_COL_DEF(RDATA_GRID => RDG,
                                        SNAME      => 'DOPER_DATE',
                                        SCAPTION   => '   ',
                                        SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_DATE,
                                        BORDER     => true,
                                        BFILTER    => true);
    PKG_P8PANELS_VISUAL.TDG_ADD_COL_DEF(RDATA_GRID => RDG,
                                        SNAME      => 'SUSE_KIND',
                                        SCAPTION   => '',
                                        SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR,
                                        BORDER     => true,
                                        BFILTER    => true);
    PKG_P8PANELS_VISUAL.TDG_ADD_COL_DEF(RDATA_GRID => RDG,
                                        SNAME      => 'NOBJ_KIND',
                                        SCAPTION   => '.    ',
                                        SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_NUMB,
                                        BVISIBLE   => false);
    PKG_P8PANELS_VISUAL.TDG_ADD_COL_DEF(RDATA_GRID => RDG,
                                        SNAME      => 'SOBJ_KIND',
                                        SCAPTION   => '',
                                        SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR,
                                        BORDER     => true,
                                        BFILTER    => true);
    PKG_P8PANELS_VISUAL.TDG_ADD_COL_DEF(RDATA_GRID => RDG,
                                        SNAME      => 'SOBJ_KIND_FULL_CODE',
                                        SCAPTION   => ' (  )',
                                        SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR,
                                        BVISIBLE   => false);
    PKG_P8PANELS_VISUAL.TDG_ADD_COL_DEF(RDATA_GRID => RDG,
                                        SNAME      => 'SUMEAS_RES',
                                        SCAPTION   => '  ',
                                        SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR,
                                        BVISIBLE   => false);
    PKG_P8PANELS_VISUAL.TDG_COL_VALS_ADD(RCOL_VALS => RCOL_VALS, NVALUE => 0, BCLEAR => true);
    PKG_P8PANELS_VISUAL.TDG_COL_VALS_ADD(RCOL_VALS => RCOL_VALS, NVALUE => 1);
    PKG_P8PANELS_VISUAL.TDG_COL_VALS_ADD(RCOL_VALS => RCOL_VALS, NVALUE => 2);
    PKG_P8PANELS_VISUAL.TDG_ADD_COL_DEF(RDATA_GRID => RDG,
                                        SNAME      => 'NCMML_STATUS',
                                        SCAPTION   => '',
                                        SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_NUMB,
                                        BORDER     => true,
                                        BFILTER    => true,
                                        RCOL_VALS  => RCOL_VALS);
    PKG_P8PANELS_VISUAL.TDG_ADD_COL_DEF(RDATA_GRID => RDG,
                                        SNAME      => 'NBREAKDOWN_PROB',
                                        SCAPTION   => '   ',
                                        SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_NUMB,
                                        BORDER     => true,
                                        BFILTER    => true,
                                        SHINT      => EQCONFIG_THOBJ_FORECAST_CLR(NMODE => 0));
    PKG_P8PANELS_VISUAL.TDG_ADD_COL_DEF(RDATA_GRID => RDG,
                                        SNAME      => 'SBREAKDOWN_PROB_COLOR',
                                        SCAPTION   => '    ',
                                        SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR,
                                        BVISIBLE   => false);
    /*   */
    begin
      /*    */
      CSQL := PKG_SQL_BUILD.COMPATIBLE(SSQL => CSQL);
      /*   */
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => 'select *');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '  from (select D.*,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => PKG_SQL_BUILD.SQLROWNUM() || ' NROW');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '          from (select C.RN NRN,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                       C.CODE SCODE,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                       C."NAME" SNAME,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                       C.OPER_DATE DOPER_DATE,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                       ST.CODE SUSE_KIND,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                       C.OBJ_KIND NOBJ_KIND,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                       OK.NAME SOBJ_KIND,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                       FORMAT_HIER_NAME(OK.COMPANY, null, OK.FULLCODE) SOBJ_KIND_FULL_CODE,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                       DM.MEAS_MNEMO SUMEAS_RES,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => PKG_SQL_BUILD.PKG_NAME(SNAME => 'UDO_PKG_EQUIPDS.CMML_STATUS_BY_EQCONFIG') || '(C.RN) NCMML_STATUS,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => PKG_SQL_BUILD.PKG_NAME(SNAME => 'UDO_PKG_EQUIPTCF.EQCONFIG_THOBJ_TCHSRV_BRKDPROB') || '(C.RN) NBREAKDOWN_PROB');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                  from EQCONFIG C');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                       left outer join HLSTATETYPES ST on C.HLSTATETYPES = ST.RN');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                       left outer join DICMUNTS DM on C.UMEAS_RES = DM.RN,');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                       EQOBJKIND OK');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                 where C.EQPARENT = :NEQPARENT');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                   and C.OBJ_KIND = OK.RN');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '                   and C.RN in (select ID from COND_BROKER_IDSMART where IDENT = :NIDENT) %ORDER_BY%) D) F');
      PKG_SQL_BUILD.APPEND(SSQL => CSQL, SELEMENT1 => '     where F.NROW between :NROW_FROM and :NROW_TO');
      /*   */
      PKG_P8PANELS_VISUAL.TDG_ORDERS_SET_QUERY(RDATA_GRID => RDG,
                                               RORDERS    => RO,
                                               SPATTERN   => '%ORDER_BY%',
                                               CSQL       => CSQL);
      /*   */
      PKG_P8PANELS_VISUAL.TDG_FILTERS_SET_QUERY(NIDENT     => NIDENT,
                                                NCOMPANY   => NCOMPANY,
                                                SUNIT      => 'EquipConfiguration',
                                                SPROCEDURE => PKG_SQL_BUILD.PKG_NAME(SNAME => 'UDO_PKG_EQUIPTCF.EQCONFIG_THOBJ_LIST_COND'),
                                                RDATA_GRID => RDG,
                                                RFILTERS   => RF);
      /*   */
      ICURSOR := PKG_SQL_DML.OPEN_CURSOR(SWHAT => 'SELECT');
      PKG_SQL_DML.PARSE(ICURSOR => ICURSOR, SQUERY => CSQL);
      /*    */
      PKG_SQL_DML.BIND_VARIABLE_NUM(ICURSOR => ICURSOR, SNAME => 'NEQPARENT', NVALUE => NEQPARENT);
      PKG_SQL_DML.BIND_VARIABLE_NUM(ICURSOR => ICURSOR, SNAME => 'NIDENT', NVALUE => NIDENT);
      PKG_SQL_DML.BIND_VARIABLE_NUM(ICURSOR => ICURSOR, SNAME => 'NROW_FROM', NVALUE => NROW_FROM);
      PKG_SQL_DML.BIND_VARIABLE_NUM(ICURSOR => ICURSOR, SNAME => 'NROW_TO', NVALUE => NROW_TO);
      /*     */
      PKG_SQL_DML.DEFINE_COLUMN_NUM(ICURSOR => ICURSOR, IPOSITION => 1);
      PKG_SQL_DML.DEFINE_COLUMN_STR(ICURSOR => ICURSOR, IPOSITION => 2);
      PKG_SQL_DML.DEFINE_COLUMN_STR(ICURSOR => ICURSOR, IPOSITION => 3);
      PKG_SQL_DML.DEFINE_COLUMN_DATE(ICURSOR => ICURSOR, IPOSITION => 4);
      PKG_SQL_DML.DEFINE_COLUMN_STR(ICURSOR => ICURSOR, IPOSITION => 5);
      PKG_SQL_DML.DEFINE_COLUMN_NUM(ICURSOR => ICURSOR, IPOSITION => 6);
      PKG_SQL_DML.DEFINE_COLUMN_STR(ICURSOR => ICURSOR, IPOSITION => 7);
      PKG_SQL_DML.DEFINE_COLUMN_STR(ICURSOR => ICURSOR, IPOSITION => 8);
      PKG_SQL_DML.DEFINE_COLUMN_STR(ICURSOR => ICURSOR, IPOSITION => 9);
      PKG_SQL_DML.DEFINE_COLUMN_NUM(ICURSOR => ICURSOR, IPOSITION => 10);
      PKG_SQL_DML.DEFINE_COLUMN_NUM(ICURSOR => ICURSOR, IPOSITION => 11);
      PKG_SQL_DML.DEFINE_COLUMN_NUM(ICURSOR => ICURSOR, IPOSITION => 12);
      /*   */
      if (PKG_SQL_DML.EXECUTE(ICURSOR => ICURSOR) = 0) then
        null;
      end if;
      /*    */
      while (PKG_SQL_DML.FETCH_ROWS(ICURSOR => ICURSOR) > 0)
      loop
        /*     */
        PKG_P8PANELS_VISUAL.TDG_ROW_ADD_CUR_COLN(RROW      => RDG_ROW,
                                                 SNAME     => 'NRN',
                                                 ICURSOR   => ICURSOR,
                                                 NPOSITION => 1,
                                                 BCLEAR    => true);
        PKG_P8PANELS_VISUAL.TDG_ROW_ADD_CUR_COLS(RROW => RDG_ROW, SNAME => 'SCODE', ICURSOR => ICURSOR, NPOSITION => 2);
        PKG_P8PANELS_VISUAL.TDG_ROW_ADD_CUR_COLS(RROW => RDG_ROW, SNAME => 'SNAME', ICURSOR => ICURSOR, NPOSITION => 3);
        PKG_P8PANELS_VISUAL.TDG_ROW_ADD_CUR_COLD(RROW      => RDG_ROW,
                                                 SNAME     => 'DOPER_DATE',
                                                 ICURSOR   => ICURSOR,
                                                 NPOSITION => 4);
        PKG_P8PANELS_VISUAL.TDG_ROW_ADD_CUR_COLS(RROW      => RDG_ROW,
                                                 SNAME     => 'SUSE_KIND',
                                                 ICURSOR   => ICURSOR,
                                                 NPOSITION => 5);
        PKG_P8PANELS_VISUAL.TDG_ROW_ADD_CUR_COLN(RROW      => RDG_ROW,
                                                 SNAME     => 'NOBJ_KIND',
                                                 ICURSOR   => ICURSOR,
                                                 NPOSITION => 6);
        PKG_P8PANELS_VISUAL.TDG_ROW_ADD_CUR_COLS(RROW      => RDG_ROW,
                                                 SNAME     => 'SOBJ_KIND',
                                                 ICURSOR   => ICURSOR,
                                                 NPOSITION => 7);
        PKG_P8PANELS_VISUAL.TDG_ROW_ADD_CUR_COLS(RROW      => RDG_ROW,
                                                 SNAME     => 'SOBJ_KIND_FULL_CODE',
                                                 ICURSOR   => ICURSOR,
                                                 NPOSITION => 8);
        PKG_P8PANELS_VISUAL.TDG_ROW_ADD_CUR_COLS(RROW      => RDG_ROW,
                                                 SNAME     => 'SUMEAS_RES',
                                                 ICURSOR   => ICURSOR,
                                                 NPOSITION => 9);
        PKG_P8PANELS_VISUAL.TDG_ROW_ADD_CUR_COLN(RROW      => RDG_ROW,
                                                 SNAME     => 'NCMML_STATUS',
                                                 ICURSOR   => ICURSOR,
                                                 NPOSITION => 10);
        PKG_SQL_DML.COLUMN_VALUE_NUM(ICURSOR => ICURSOR, IPOSITION => 11, NVALUE => NBREAKDOWN_PROB);
        PKG_P8PANELS_VISUAL.TDG_ROW_ADD_COL(RROW => RDG_ROW, SNAME => 'NBREAKDOWN_PROB', NVALUE => NBREAKDOWN_PROB);
        PKG_P8PANELS_VISUAL.TDG_ROW_ADD_COL(RROW   => RDG_ROW,
                                            SNAME  => 'SBREAKDOWN_PROB_COLOR',
                                            SVALUE => EQCONFIG_THOBJ_FORECAST_CLR(NMODE => 1, NVALUE => NBREAKDOWN_PROB));
        /*     */
        PKG_P8PANELS_VISUAL.TDG_ADD_ROW(RDATA_GRID => RDG, RROW => RDG_ROW);
      end loop;
      /*   */
      PKG_SQL_DML.CLOSE_CURSOR(ICURSOR => ICURSOR);
    exception
      when others then
        PKG_SQL_DML.CLOSE_CURSOR(ICURSOR => ICURSOR);
        raise;
    end;
    /*   */
    COUT := PKG_P8PANELS_VISUAL.TDG_TO_XML(RDATA_GRID => RDG, NINCLUDE_DEF => NINCLUDE_DEF);
  end EQCONFIG_THOBJ_LIST;
  
  /*        */
  function EQCONFIG_THOBJ_GET_NXTEQTCHSRV
  (
    NEQCONFIG               in number,        -- .   
    NSTATE                  in number := null --  (null - )
  ) return                  date              --    
  is
    DRES                    PKG_STD.TLDATE;   --   
  begin
    /*     ,   ,      .  */
    select min(T.DATEPRD_BEG)
      into DRES
      from EQTCHSRV T
     where T.EQCONFIG_TECH = NEQCONFIG
       and ((NSTATE is null) or ((NSTATE is not null) and (T.STATE = NSTATE)))
       and T.DATEPRD_BEG >= sysdate;
    /*   */
    return DRES;
  exception
    when others then
      return null;
  end EQCONFIG_THOBJ_GET_NXTEQTCHSRV;
  
  /*         */
  procedure EQCONFIG_THOBJ_SELECT_EQTCHSRV
  (
    NEQTCHSRV               in number := null, -- .      (null - )
    NEQCONFIG               in number := null, -- .    (null - )
    NSTATE                  in number := null, --  (null - )
    NIDENT                  out number         --  
  )
  is
    NTMP                    PKG_STD.TREF;      -- .    
  begin
    /*    .  */
    for C in (select T.RN
                from EQTCHSRV T
               where ((NEQTCHSRV is null) or ((NEQTCHSRV is not null) and (T.RN = NEQTCHSRV)))
                 and ((NEQCONFIG is null) or ((NEQCONFIG is not null) and (T.EQCONFIG_TECH = NEQCONFIG)))
                 and ((NEQTCHSRV is not null) or ((NEQTCHSRV is null) and (T.DATEPRD_BEG >= sysdate)))
                 and ((NSTATE is null) or ((NSTATE is not null) and (T.STATE = NSTATE))))
    loop
      /*      */
      if (NIDENT is null) then
        NIDENT := GEN_IDENT();
      end if;
      /*     */
      P_SELECTLIST_INSERT(NIDENT => NIDENT, NDOCUMENT => C.RN, SUNITCODE => 'EquipTechServices', NRN => NTMP);
    end loop;
  end EQCONFIG_THOBJ_SELECT_EQTCHSRV;
  
  /*          */
  function EQCONFIG_THOBJ_GET_NXTEQRPSHT
  (
    NEQCONFIG               in number,        -- .   
    NSTATE                  in number := null --  (null - )
  ) return                  date              --     
  is
    DRES                    PKG_STD.TLDATE;   --   
  begin
    /*     ,   ,      .  */
    select min(T.DATEPLAN_BEG)
      into DRES
      from EQRPSHEETS T
     where T.EQCONFIG = NEQCONFIG
       and ((NSTATE is null) or ((NSTATE is not null) and (T.STATE = NSTATE)))
       and T.DATEPLAN_BEG >= sysdate;
    /*   */
    return DRES;
  exception
    when others then
      return null;
  end EQCONFIG_THOBJ_GET_NXTEQRPSHT;
  
  /*      */
  procedure EQCONFIG_THOBJ_SELECT_EQRPSHT
  (
    NEQRPSHEETS             in number := null, -- .    (null - )
    NEQCONFIG               in number := null, -- .    (null - )
    NSTATE                  in number := null, --  (null - )
    NIDENT                  out number         --  
  )
  is
    NTMP                    PKG_STD.TREF;      -- .    
  begin
    /*    .  */
    for C in (select T.RN
                from EQRPSHEETS T
               where ((NEQRPSHEETS is null) or ((NEQRPSHEETS is not null) and (T.RN = NEQRPSHEETS)))
                 and ((NEQCONFIG is null) or ((NEQCONFIG is not null) and (T.EQCONFIG = NEQCONFIG)))
                 and ((NEQRPSHEETS is not null) or ((NEQRPSHEETS is null) and (T.DATEPLAN_BEG >= sysdate)))
                 and ((NSTATE is null) or ((NSTATE is not null) and (T.STATE = NSTATE))))
    loop
      /*      */
      if (NIDENT is null) then
        NIDENT := GEN_IDENT();
      end if;
      /*     */
      P_SELECTLIST_INSERT(NIDENT => NIDENT, NDOCUMENT => C.RN, SUNITCODE => 'EquipRepairSheets', NRN => NTMP);
    end loop;
  end EQCONFIG_THOBJ_SELECT_EQRPSHT;
  
  /*             ( )   */
  function EQCONFIG_THOBJ_GEN_NXTRPR
  (
    NEQCONFIG               in number       -- .   
  ) return                  date            --   
  is
    DNXTEQTCHSRV            PKG_STD.TLDATE; --       
    DNXTEQRPSHT             PKG_STD.TLDATE; --        
    DRES                    PKG_STD.TLDATE; --   
  begin
    /*       */
    DNXTEQTCHSRV := EQCONFIG_THOBJ_GET_NXTEQTCHSRV(NEQCONFIG => NEQCONFIG);
    /*      */
    DNXTEQRPSHT := EQCONFIG_THOBJ_GET_NXTEQRPSHT(NEQCONFIG => NEQCONFIG);
    /*   */
    if ((DNXTEQRPSHT is not null) and (DNXTEQTCHSRV is not null)) then
      if (DNXTEQRPSHT < DNXTEQTCHSRV) then
        DRES := DNXTEQRPSHT;
      else
        DRES := DNXTEQTCHSRV;
      end if;
    else
      DRES := COALESCE(DNXTEQTCHSRV, DNXTEQRPSHT);
    end if;
    /*   */
    return DRES;
  end EQCONFIG_THOBJ_GEN_NXTRPR;
  
  /*     */
  procedure EQCONFIG_THOBJ_CARD
  (
    NEQCONFIG               in number,       -- .   
    COUT                    out clob         --  
  )
  is
    NCUR                    integer;         --    
    XDOC                    PKG_XMAKE.TNODE; --   
    XCARD                   PKG_XMAKE.TNODE; -- XML-
  begin
    /*   */
    NCUR := PKG_XMAKE.OPEN_CURSOR();
    /*      */
    for C in (select T.RN        NRN,
                     T.CODE      SCODE,
                     T.NAME      SNAME,
                     T.OPER_DATE DOPER_DATE,
                     OK.NAME     SEQOBJKIND
                from EQCONFIG  T,
                     EQOBJKIND OK
               where T.RN = NEQCONFIG
                 and T.OBJ_KIND = OK.RN)
    loop
      /*   */
      XCARD := PKG_XMAKE.ELEMENT(ICURSOR     => NCUR,
                                 SNAME       => 'techObj',
                                 RATTRIBUTES => PKG_XMAKE.ATTRIBUTES(ICURSOR      => NCUR,
                                                                     RATTRIBUTE00 => PKG_XMAKE.ATTRIBUTE(ICURSOR => NCUR,
                                                                                                         SNAME   => 'NRN',
                                                                                                         NVALUE  => C.NRN),
                                                                     RATTRIBUTE01 => PKG_XMAKE.ATTRIBUTE(ICURSOR => NCUR,
                                                                                                         SNAME   => 'SCODE',
                                                                                                         SVALUE  => C.SCODE),
                                                                     RATTRIBUTE02 => PKG_XMAKE.ATTRIBUTE(ICURSOR => NCUR,
                                                                                                         SNAME   => 'SNAME',
                                                                                                         SVALUE  => C.SNAME),
                                                                     RATTRIBUTE03 => PKG_XMAKE.ATTRIBUTE(ICURSOR => NCUR,
                                                                                                         SNAME   => 'DOPER_DATE',
                                                                                                         DVALUE  => C.DOPER_DATE),
                                                                     RATTRIBUTE04 => PKG_XMAKE.ATTRIBUTE(ICURSOR => NCUR,
                                                                                                         SNAME   => 'DNEXT_EQTCHSRV',
                                                                                                         SVALUE  => TO_CHAR(EQCONFIG_THOBJ_GET_NXTEQTCHSRV(NEQCONFIG => C.NRN),
                                                                                                                            'dd.mm.yyyy hh24:mi:ss')),
                                                                     RATTRIBUTE05 => PKG_XMAKE.ATTRIBUTE(ICURSOR => NCUR,
                                                                                                         SNAME   => 'DNEXT_EQRPSHEET',
                                                                                                         SVALUE  => TO_CHAR(EQCONFIG_THOBJ_GET_NXTEQRPSHT(NEQCONFIG => C.NRN),
                                                                                                                            'dd.mm.yyyy hh24:mi:ss')),
                                                                     RATTRIBUTE06 => PKG_XMAKE.ATTRIBUTE(ICURSOR => NCUR,
                                                                                                         SNAME   => 'SEQOBJKIND',
                                                                                                         SVALUE  => C.SEQOBJKIND)));
    end loop;
    /*  XML-   */
    XDOC := PKG_XMAKE.ELEMENT(ICURSOR => NCUR, SNAME => 'XDATA', RNODE00 => XCARD);
    /*   */
    COUT := PKG_XMAKE.SERIALIZE_TO_CLOB(ICURSOR => NCUR,
                                        ITYPE   => PKG_XMAKE.CONTENT_,
                                        RNODE   => XDOC,
                                        RHEADER => PKG_XHEADER.WRAP_ALL(SVERSION    => PKG_XHEADER.VERSION_1_0_,
                                                                        SENCODING   => PKG_XHEADER.ENCODING_UTF_,
                                                                        SSTANDALONE => PKG_XHEADER.STANDALONE_YES_));
    /*   */
    PKG_XMAKE.CLOSE_CURSOR(ICURSOR => NCUR);
  end EQCONFIG_THOBJ_CARD;
  
  /*           */
  procedure EQCONFIG_THOBJ_FORECAST_BCLR
  (
    NDATASET_IDENT          in number,  --   
    NDATASET_CONFIG_IDENT   in number,  --    
    NREQUEST_CONFIG_IDENT   in number   --        
  )
  is
  begin
    /*      */
    P_FILE_BUFFER_CLEAR(NIDENT => NDATASET_IDENT);
    P_FILE_BUFFER_CLEAR(NIDENT => NDATASET_CONFIG_IDENT);
    P_FILE_BUFFER_CLEAR(NIDENT => NREQUEST_CONFIG_IDENT);
  end EQCONFIG_THOBJ_FORECAST_BCLR;

  /*           (  ) */
  procedure EQCONFIG_THOBJ_FORECAST_BCLRAT
  (
    NDATASET_IDENT          in number,                 --   
    NDATASET_CONFIG_IDENT   in number,                 --    
    NREQUEST_CONFIG_IDENT   in number                  --        
  )
  is
    RPROC_PARAMS            PKG_CONTPRMLOC.TCONTAINER; --  
  begin
    /*     */
    PKG_CONTPRMLOC.PURGE(RCONTAINER => RPROC_PARAMS);
    /*    */
    PKG_CONTPRMLOC.PUTN(RCONTAINER => RPROC_PARAMS,
                        SNAME      => 'NDATASET_IDENT',
                        NVALUE     => NDATASET_IDENT,
                        NIN_OUT    => PKG_STD.PARAM_TYPE_IN());
    PKG_CONTPRMLOC.PUTN(RCONTAINER => RPROC_PARAMS,
                        SNAME      => 'NDATASET_CONFIG_IDENT',
                        NVALUE     => NDATASET_CONFIG_IDENT,
                        NIN_OUT    => PKG_STD.PARAM_TYPE_IN());
    PKG_CONTPRMLOC.PUTN(RCONTAINER => RPROC_PARAMS,
                        SNAME      => 'NREQUEST_CONFIG_IDENT',
                        NVALUE     => NREQUEST_CONFIG_IDENT,
                        NIN_OUT    => PKG_STD.PARAM_TYPE_IN());
    /*  (  ) */
    PKG_SQL_CALL.EXECUTE_STORED_AT(SSTORED_NAME     => 'UDO_PKG_EQUIPTCF.EQCONFIG_THOBJ_FORECAST_BCLR',
                                   RPARAM_CONTAINER => RPROC_PARAMS,
                                   BOVERLOAD_ENV    => true);
    /*     */
    PKG_CONTPRMLOC.PURGE(RCONTAINER => RPROC_PARAMS);
  end EQCONFIG_THOBJ_FORECAST_BCLRAT;

  /*         */
  procedure EQCONFIG_THOBJ_FORECAST_PRLG
  (
    NEQUIPDSCMML            in number,                 -- .      
    NDATASET_IDENT          in number,                 --   
    NDATASET_CONFIG_IDENT   in number,                 --    
    NREQUEST_CONFIG_IDENT   in number,                 --    
    SURL                    out varchar2,              --   
    SAUTH_TOKEN             out varchar2,              --    
    SDATASET_ID             out varchar2,              --    
    CDATASET_CONFIG         out clob,                  --    
    SDATASET_URL            out varchar2,              --      
    SCLASS_MACHINE          out varchar2,              --     
    STASK                   out varchar2               --    (.  UDO_PKG_EQUIPDS_BASE.SCMML_TASK_*)
  )
  is
    REQUIPDSCMML            UDO_T_EQUIPDSCMML%rowtype; --  
    REQUIPDSCM              UDO_T_EQUIPDSCM%rowtype;   --     ,   
    REXSSERVICEFN_SEND_RQ   EXSSERVICEFN%rowtype;      --      
    REXSSERVICE_SEND_RQ     EXSSERVICE%rowtype;        --      
    REXSSERVICEFN_FRCST_MD  EXSSERVICEFN%rowtype;      --             
    REXSSERVICE_FRCST_MD    EXSSERVICE%rowtype;        --             
    NAPI_ROOT_INDEX         PKG_STD.TNUMBER;           --    API     
    NCNT                    PKG_STD.TNUMBER;           --     
  begin
    /*     */
    SDATASET_URL := GET_OPTIONS_STR(SCODE => 'EXSService_AppServer');
    if (SDATASET_URL is null) then
      P_EXCEPTION(0,
                  '      "   ( )" ( - 1929,  - "EXSService_AppServer").');
    end if;
    /*     */
    begin
      select count(T.RN)
        into NCNT
        from FILE_BUFFER T
       where T.IDENT = NDATASET_IDENT
         and T.BDATA is not null;
    exception
      when others then
        P_EXCEPTION(0, '      .');
    end;
    if (NCNT > 1) then
      P_EXCEPTION(0, '     .');
    end if;
    if (NCNT = 0) then
      P_EXCEPTION(0, '     .');
    end if;
    /*      */
    for C in (select T.DATA CDATA from FILE_BUFFER T where T.IDENT = NDATASET_CONFIG_IDENT)
    loop
      if (CDATASET_CONFIG is not null) then
        P_EXCEPTION(0,
                    '      .');
      end if;
      CDATASET_CONFIG := C.CDATA;
    end loop;
    if (CDATASET_CONFIG is null) then
      P_EXCEPTION(0, '      .');
    end if;
    /*     */
    begin
      select count(T.RN)
        into NCNT
        from FILE_BUFFER T
       where T.IDENT = NREQUEST_CONFIG_IDENT
         and T.BDATA is not null;
    exception
      when others then
        P_EXCEPTION(0,
                    '      .');
    end;
    if (NCNT > 1) then
      P_EXCEPTION(0,
                  '     .');
    end if;
    if (NCNT = 0) then
      P_EXCEPTION(0,
                  '     .');
    end if;
    /*    */
    REQUIPDSCMML := UDO_PKG_EQUIPDS_BASE.CMML_GET(NFLAG_SMART => 0, NRN => NEQUIPDSCMML);
    if (REQUIPDSCMML.STATUS <> UDO_PKG_EQUIPDS_BASE.NCMML_STATUS_PROCESSED) then
      P_EXCEPTION(0,
                  ' (  %s)      "".',
                  TO_CHAR(REQUIPDSCMML.RN));
    end if;
    /*       */
    REQUIPDSCM := UDO_PKG_EQUIPDS_BASE.CM_GET(NFLAG_SMART => 0, NRN => REQUIPDSCMML.PRN);
    /*     ,     */
    REXSSERVICEFN_SEND_RQ := GET_EXSSERVICEFN_ID(NFLAG_SMART => 0, NRN => REQUIPDSCM.EXSSERVICEFN_SEND_RQ);
    REXSSERVICE_SEND_RQ   := GET_EXSSERVICE_ID(NFLAG_SMART => 0, NRN => REXSSERVICEFN_SEND_RQ.PRN);
    /*  URL   */
    NAPI_ROOT_INDEX := INSTR(REXSSERVICE_SEND_RQ.SRV_ROOT, SFW_API_ROOT);
    if (NAPI_ROOT_INDEX = 0) then
      P_EXCEPTION(0,
                  '     "%s" -     API ("%s").',
                  REXSSERVICE_SEND_RQ.SRV_ROOT,
                  SFW_API_ROOT);
    end if;
    SURL := SUBSTR(REXSSERVICE_SEND_RQ.SRV_ROOT, 1, NAPI_ROOT_INDEX - 1) || SFW_API_ROOT || SFW_API_FORECAST;
    /*     */
    SAUTH_TOKEN := TO_CHAR(BASE64_ENCODE(CLOB2BLOB(REXSSERVICE_SEND_RQ.SRV_USER || ':' ||
                                                   BLOB2CLOB(BASE64_DECODE(REXSSERVICE_SEND_RQ.SRV_PASS)))));
    /*       (   -    ,       "data_url"    ) */
    SDATASET_ID := TO_CHAR(NDATASET_IDENT);
    /*     ,       */
    REXSSERVICEFN_FRCST_MD := GET_EXSSERVICEFN_ID(NFLAG_SMART => 0, NRN => REQUIPDSCM.EXSSERVICEFN_FRCST_MD);
    REXSSERVICE_FRCST_MD   := GET_EXSSERVICE_ID(NFLAG_SMART => 0, NRN => REXSSERVICEFN_FRCST_MD.PRN);
    /*         (    ,    ,  ) */
    if ((SUBSTR(SDATASET_URL, -1) <> '/') and (SUBSTR(REXSSERVICE_FRCST_MD.SRV_ROOT, 1, 1) <> '/')) then
      SDATASET_URL := SDATASET_URL || '/';
    end if;
    SDATASET_URL := SDATASET_URL || REXSSERVICE_FRCST_MD.SRV_ROOT;
    if ((SUBSTR(SDATASET_URL, -1) <> '/') and (SUBSTR(REXSSERVICEFN_FRCST_MD.FN_URL, 1, 1) <> '/')) then
      SDATASET_URL := SDATASET_URL || '/';
    end if;
    SDATASET_URL := SDATASET_URL || REXSSERVICEFN_FRCST_MD.FN_URL || '?NDATASET_IDENT=' || TO_CHAR(NDATASET_IDENT);
    /*      */
    begin
      select T.CODE into SCLASS_MACHINE from EQOBJKIND T where T.RN = REQUIPDSCM.EQOBJKIND;
    exception
      when NO_DATA_FOUND then
        PKG_MSG.RECORD_NOT_FOUND(NFLAG_SMART => 0, NDOCUMENT => REQUIPDSCM.EQOBJKIND, SUNIT_TABLE => 'EQOBJKIND');
    end;
    /*    */
    STASK := REQUIPDSCMML.TASK;
  exception
    when others then
      /*   */
      EQCONFIG_THOBJ_FORECAST_BCLRAT(NDATASET_IDENT        => NDATASET_IDENT,
                                     NDATASET_CONFIG_IDENT => NDATASET_CONFIG_IDENT,
                                     NREQUEST_CONFIG_IDENT => NREQUEST_CONFIG_IDENT);
      /*   */
      raise;
  end EQCONFIG_THOBJ_FORECAST_PRLG;

  /*         */
  procedure EQCONFIG_THOBJ_FORECAST_EPLG
  (
    NDATASET_IDENT          in number,    --   
    NDATASET_CONFIG_IDENT   in number,    --    
    NREQUEST_CONFIG_IDENT   in number,    --        
    NEQCONFIG               in number,    -- .   
    NEQUIPDSCMML            in number,    -- .  
    CFORECAST               in clob       --   
  )
  is
    NEQUIPDSCMMLH           PKG_STD.TREF; -- .    
    BRQ                     blob;         --     
  begin
    /*     */
    begin
      select T.BDATA
        into BRQ
        from FILE_BUFFER T
       where T.IDENT = NREQUEST_CONFIG_IDENT
         and T.BDATA is not null;
    exception
      when NO_DATA_FOUND then
        P_EXCEPTION(0, '     .');
      when TOO_MANY_ROWS then
        P_EXCEPTION(0, '     .');
    end;
    /*     */
    UDO_PKG_EQUIPDS_BASE.CMMLH_INS(NPRN       => NEQUIPDSCMML,
                                   NEQCONFIG  => NEQCONFIG,
                                   SRQ_AUTHID => UTILIZER(),
                                   DRQ_DATE   => sysdate,
                                   BRQ        => BRQ,
                                   NRN        => NEQUIPDSCMMLH);
    /*    */
    UDO_PKG_EQUIPDS_BASE.CMMLH_SET_FORECAST(NRN => NEQUIPDSCMMLH, BFORECAST => BASE64_DECODE(LCSRCE => CFORECAST));
    /*   */
    EQCONFIG_THOBJ_FORECAST_BCLR(NDATASET_IDENT        => NDATASET_IDENT,
                                 NDATASET_CONFIG_IDENT => NDATASET_CONFIG_IDENT,
                                 NREQUEST_CONFIG_IDENT => NREQUEST_CONFIG_IDENT);
  exception
    when others then
      /*   */
      EQCONFIG_THOBJ_FORECAST_BCLRAT(NDATASET_IDENT        => NDATASET_IDENT,
                                     NDATASET_CONFIG_IDENT => NDATASET_CONFIG_IDENT,
                                     NREQUEST_CONFIG_IDENT => NREQUEST_CONFIG_IDENT);
      /*   */
      raise;
  end EQCONFIG_THOBJ_FORECAST_EPLG;
  
  /*       */
  function EQCONFIG_THOBJ_FORECAST_CLR
  (
    NMODE                   in number := 0, --   (0 -     , 1 -   , 2 -   
    NVALUE                  in number :=0   --   
  ) return                  varchar2        --      
  is
  begin
    /*    */
    case NMODE
      /*      */
      when 0 then
        return '<b style="color:red"></b> -    60%.<br>' || '<b style="color:orange"></b> -    30%  60%<br>' || '<b style="color:green"> </b> -    30%';
      /*    */
      when 1 then
        begin
          if (NVALUE < 30) then
            return 'success';
          else
            if ((NVALUE >= 30) and (NVALUE < 60)) then
              return 'warning';
            else
              return 'error';
            end if;
          end if;
        end;
      /*    */
      when 2 then
        begin
          if (NVALUE < 30) then
            return 'success.main';
          else
            if ((NVALUE >= 30) and (NVALUE < 60)) then
              return 'warning.main';
            else
              return 'error.main';
            end if;
          end if;
        end;
      /*   */
      else
        return null;
    end case;
  end EQCONFIG_THOBJ_FORECAST_CLR;  
  
  /*        */
  procedure EQCONFIG_THOBJ_FORECAST_CRD
  (
    NEQCONFIG               in number,                          -- .    
    DFORECAST_DATE          in date,                            --   
    NFORECAST               in number,                          --  ,   
    SDICMUNTS               in varchar2,                        --   
    STASK                   in varchar2,                        --  (.  UDO_PKG_EQUIPDS_BASE.CMML_TASK_*)
    COUT                    out clob                            --    
  )
  is
    NCUR                    integer;                            --    
    XDOC                    PKG_XMAKE.TNODE;                    --   
    XROOT                   PKG_XMAKE.TNODE;                    --    
    RCH                     PKG_P8PANELS_VISUAL.TCHART;         -- 
    RCH_DS                  PKG_P8PANELS_VISUAL.TCHART_DATASET; --  
    CCHART                  clob;                               --  
    NBREAKDOWN_PROB         PKG_STD.TNUMBER;                    --    
    NBREAKDOWN_PROB_CUR     PKG_STD.TNUMBER;                    --     (      /. )
    DNEXT_REPAIR            PKG_STD.TLDATE;                     --       /. 
  begin
    /*         /    .     */
    DNEXT_REPAIR := EQCONFIG_THOBJ_GEN_NXTRPR(NEQCONFIG => NEQCONFIG);
    if (DNEXT_REPAIR is null) then
      NBREAKDOWN_PROB := 100;
    else
      if (sysdate + NFORECAST > DNEXT_REPAIR) then
        NBREAKDOWN_PROB := 0;
      end if;
    end if;
    /*   */
    NCUR := PKG_XMAKE.OPEN_CURSOR();
    /*    */
    XROOT := PKG_XMAKE.CONCAT(ICURSOR => NCUR,
                              RNODE00 => XROOT,
                              RNODE01 => PKG_XMAKE.ELEMENT(ICURSOR  => NCUR,
                                                           SNAME    => 'SDICMUNTS',
                                                           RVALUE00 => PKG_XMAKE.VALUE(ICURSOR => NCUR, SVALUE => SDICMUNTS)));
    /*   */
    XROOT := PKG_XMAKE.CONCAT(ICURSOR => NCUR,
                              RNODE00 => XROOT,
                              RNODE01 => PKG_XMAKE.ELEMENT(ICURSOR  => NCUR,
                                                           SNAME    => 'NFORECAST',
                                                           RVALUE00 => PKG_XMAKE.VALUE(ICURSOR => NCUR, NVALUE => NFORECAST)));
    /*     */
    XROOT := PKG_XMAKE.CONCAT(ICURSOR => NCUR,
                              RNODE00 => XROOT,
                              RNODE01 => PKG_XMAKE.ELEMENT(ICURSOR  => NCUR,
                                                           SNAME    => 'STASK',
                                                           RVALUE00 => PKG_XMAKE.VALUE(ICURSOR => NCUR, SVALUE => STASK)));
    /*     */
    XROOT := PKG_XMAKE.CONCAT(ICURSOR => NCUR,
                              RNODE00 => XROOT,
                              RNODE01 => PKG_XMAKE.ELEMENT(ICURSOR  => NCUR,
                                                           SNAME    => 'STASK_NAME',
                                                           RVALUE00 => PKG_XMAKE.VALUE(ICURSOR => NCUR,
                                                                                       SVALUE  => UDO_PKG_EQUIPDS_BASE.CMML_TASK_NAME(STASK => STASK))));
    /*       */
    XROOT := PKG_XMAKE.CONCAT(ICURSOR => NCUR,
                              RNODE00 => XROOT,
                              RNODE01 => PKG_XMAKE.ELEMENT(ICURSOR  => NCUR,
                                                           SNAME    => 'DNEXT_REPAIR',
                                                           RVALUE00 => PKG_XMAKE.VALUE(ICURSOR => NCUR,
                                                                                       DVALUE  => DNEXT_REPAIR)));
    /*           */
    if (DNEXT_REPAIR is not null) then
      /*          */
      RCH := PKG_P8PANELS_VISUAL.TCHART_MAKE(STYPE     => PKG_P8PANELS_VISUAL.SCHART_TYPE_LINE,
                                             STITLE    => '      / ',
                                             SLGND_POS => PKG_P8PANELS_VISUAL.SCHART_LGND_POS_TOP);
      /*    */
      RCH_DS := PKG_P8PANELS_VISUAL.TCHART_DATASET_MAKE(SCAPTION => '     (%)');
      /*   5         */
      for C in (select ROWNUM,
                       D.DDATEPRD_BEG
                  from (select T.DDATEPRD_BEG
                          from (select P.DATEPRD_BEG DDATEPRD_BEG
                                  from EQTCHSRV P
                                 where P.EQCONFIG_TECH = NEQCONFIG
                                   and P.DATEPRD_BEG >= sysdate
                                union
                                select R.DATEPLAN_BEG DDATEPRD_BEG
                                  from EQRPSHEETS R
                                 where R.EQCONFIG = NEQCONFIG
                                   and R.DATEPLAN_BEG >= sysdate) T
                         order by T.DDATEPRD_BEG) D
                 where ROWNUM <= 5)
      loop
        /*     */
        PKG_P8PANELS_VISUAL.TCHART_ADD_LABEL(RCHART => RCH, SLABEL => TO_CHAR(C.DDATEPRD_BEG, 'dd.mm.yyyy'));
        /*         */
        NBREAKDOWN_PROB_CUR := UDO_PKG_EQUIPDS_BASE.CMML_RUL_BREAKDOWN_PROB(NFORECAST      => NFORECAST,
                                                                            DFORECAST_DATE => DFORECAST_DATE,
                                                                            DDATE          => C.DDATEPRD_BEG);
        /*         -   */
        if (NBREAKDOWN_PROB is null) then
          NBREAKDOWN_PROB := NBREAKDOWN_PROB_CUR;
        end if;
        /*      */
        PKG_P8PANELS_VISUAL.TCHART_DATASET_ADD_ITEM(RDATASET => RCH_DS, NVALUE => NBREAKDOWN_PROB_CUR);
      end loop;
      /*      */
      PKG_P8PANELS_VISUAL.TCHART_ADD_DATASET(RCHART => RCH, RDATASET => RCH_DS);
      /*   */
      CCHART := PKG_P8PANELS_VISUAL.TCHART_TO_XML(RCHART => RCH, NINCLUDE_DEF => 1);
    end if;
    /*            */
    XROOT := PKG_XMAKE.CONCAT(ICURSOR => NCUR,
                              RNODE00 => XROOT,
                              RNODE01 => PKG_XMAKE.ELEMENT(ICURSOR  => NCUR,
                                                           SNAME    => 'NBREAKDOWN_PROB',
                                                           RVALUE00 => PKG_XMAKE.VALUE(ICURSOR => NCUR,
                                                                                       NVALUE  => NBREAKDOWN_PROB)));
    /*             */
    XROOT := PKG_XMAKE.CONCAT(ICURSOR => NCUR,
                              RNODE00 => XROOT,
                              RNODE01 => PKG_XMAKE.ELEMENT(ICURSOR  => NCUR,
                                                           SNAME    => 'SBREAKDOWN_PROB_COLOR',
                                                           RVALUE00 => PKG_XMAKE.VALUE(ICURSOR => NCUR,
                                                                                       SVALUE  => EQCONFIG_THOBJ_FORECAST_CLR(NMODE  => 2,
                                                                                                                              NVALUE => NBREAKDOWN_PROB))));
    /*     */
    XROOT := PKG_XMAKE.CONCAT(ICURSOR => NCUR,
                              RNODE00 => XROOT,
                              RNODE01 => PKG_XMAKE.ELEMENT(ICURSOR  => NCUR,
                                                           SNAME    => 'XCHART',
                                                           RVALUE00 => PKG_XMAKE.VALUE(ICURSOR => NCUR, LCVALUE => CCHART)));
    /*  XML-  */
    XDOC := PKG_XMAKE.ELEMENT(ICURSOR => NCUR, SNAME => 'XDATA', RNODE00 => XROOT);
    /*   CLOB */
    COUT := PKG_XMAKE.SERIALIZE_TO_CLOB(ICURSOR => NCUR,
                                        ITYPE   => PKG_XMAKE.CONTENT_,
                                        RNODE   => XDOC,
                                        RHEADER => PKG_XHEADER.WRAP_ALL(SVERSION    => PKG_XHEADER.VERSION_1_0_,
                                                                        SENCODING   => PKG_XHEADER.ENCODING_UTF_,
                                                                        SSTANDALONE => PKG_XHEADER.STANDALONE_YES_));
    /*   */
    PKG_XMAKE.CLOSE_CURSOR(ICURSOR => NCUR);
  end EQCONFIG_THOBJ_FORECAST_CRD;
  
  /*          */
  procedure EQCONFIG_THOBJ_FORECAST_CRDP
  (
    CFORECAST               in clob,             --    
    SFORECAST_DESC          out varchar2,        --  
    SFORECAST_DESC_COLOR    out varchar2         --   
  )
  is
    XDOC                    PKG_XPATH.TDOCUMENT; --  -
    XROOT                   PKG_XPATH.TNODE;     --   
    SDICMUNTS               PKG_STD.TSTRING;     --   
    NFORECAST               PKG_STD.TNUMBER;     --    
    NBREAKDOWN_PROB         PKG_STD.TNUMBER;     --    
  begin
    /*  - */
    XDOC := PKG_XPATH.PARSE_FROM_CLOB(LCXML => CFORECAST);
    /*    */
    XROOT := PKG_XPATH.ROOT_NODE(RDOCUMENT => XDOC);
    /*    */
    SDICMUNTS := PKG_XPATH.VALUE(RNODE => PKG_XPATH.SINGLE_NODE(RPARENT_NODE => XROOT, SPATTERN => 'XDATA/SDICMUNTS'));
    /*   */
    NFORECAST := PKG_XPATH.VALUE_NUM(RNODE => PKG_XPATH.SINGLE_NODE(RPARENT_NODE => XROOT, SPATTERN => 'XDATA/NFORECAST'));
    /*      */
    NBREAKDOWN_PROB := PKG_XPATH.VALUE_NUM(RNODE => PKG_XPATH.SINGLE_NODE(RPARENT_NODE => XROOT,
                                                                          SPATTERN     => 'XDATA/NBREAKDOWN_PROB'));
    /*   */
    if (NFORECAST is not null) then
      /*    */
      SFORECAST_DESC := TO_CHAR(ROUND(NFORECAST)) || SDICMUNTS || ' / ' || TO_CHAR(ROUND(NBREAKDOWN_PROB)) || '%';
      /*       */
      SFORECAST_DESC_COLOR := EQCONFIG_THOBJ_FORECAST_CLR(NMODE => 1, NVALUE => NBREAKDOWN_PROB);
    end if;
  exception
    when others then
      null;
  end EQCONFIG_THOBJ_FORECAST_CRDP;

  /*              RUL- */
  function EQCONFIG_THOBJ_TCHSRV_BRKDPROB
  (
    NEQCONFIG               in number        -- .   
  ) return                  number           --    
  is
    NRES                    PKG_STD.TNUMBER; --   
    DFORECAST_DATE          PKG_STD.TLDATE;  --  
    NFORECAST               PKG_STD.TNUMBER; --     
    DCALC_DATE              PKG_STD.TLDATE;  --   
  begin
    /*       */
    DCALC_DATE := EQCONFIG_THOBJ_GEN_NXTRPR(NEQCONFIG => NEQCONFIG);
    /*    */
    if (DCALC_DATE is not null) then
      /*     */
      for C in (select T.RQ_DATE DFORECAST_DATE,
                       T.FORECAST
                  from UDO_T_EQUIPDSCMMLH T,
                       UDO_T_EQUIPDSCMML  CMML
                 where T.EQCONFIG = NEQCONFIG
                   and T.PRN = CMML.RN
                   and CMML.TASK = UDO_PKG_EQUIPDS_BASE.SCMML_TASK_RUL
                 order by T.RQ_DATE desc)
      loop
        DFORECAST_DATE := C.DFORECAST_DATE;
        UDO_PKG_EQUIPDS.CMMLH_PARSE_FORECAST(CFORECAST => BLOB2CLOB(LBDATA => C.FORECAST), NFORECAST => NFORECAST);
        exit;
      end loop;
      /*     */
      if (NFORECAST is not null) then
        NRES := UDO_PKG_EQUIPDS_BASE.CMML_RUL_BREAKDOWN_PROB(NFORECAST      => NFORECAST,
                                                             DFORECAST_DATE => DFORECAST_DATE,
                                                             DDATE          => DCALC_DATE);
      end if;
    end if;
    /*  ,   */
    return NRES;
  end EQCONFIG_THOBJ_TCHSRV_BRKDPROB;
  
  /*         */
  procedure EQCONFIG_THOBJ_CHNG_EQTCHSRV
  (
    NEQCONFIG               in number,                  -- .   
    NEQTCHSRV               in number,                  -- .     
    DPLANDATE_FROM          in date                     --     
  )
  is
    REQTCHSRV               EQTCHSRV%rowtype;           --     
    RDSCMMLH                UDO_T_EQUIPDSCMMLH%rowtype; --   
    NDIFF                   PKG_STD.TNUMBER;            --     
    DDATEPRD_BEG            PKG_STD.TLDATE;             --   
    DDATEPRD_END            PKG_STD.TLDATE;             --   
    SNOTE                   PKG_STD.TSTRING;            --  
  begin
    /*   */
    begin
      select T.* into REQTCHSRV from EQTCHSRV T where T.RN = NEQTCHSRV;
    exception
      when NO_DATA_FOUND then
        PKG_MSG.RECORD_NOT_FOUND(NFLAG_SMART => 0, NDOCUMENT => NEQTCHSRV, SUNIT_TABLE => 'EquipTechServices');
    end;
    /*     */
    begin
      select T.*
        into RDSCMMLH
        from UDO_T_EQUIPDSCMMLH T
       where T.RN = (select max(TT.RN) from UDO_T_EQUIPDSCMMLH TT where TT.EQCONFIG = NEQCONFIG);
    exception
      when others then
        P_EXCEPTION(0,
                    '   -   .');
    end;
    /* ,        */
    if (F_DOCLINKS_LINK_OUT_DOC(SIN_UNITCODE  => 'EquipTechServices',
                                NIN_DOCUMENT  => REQTCHSRV.RN,
                                SOUT_UNITCODE => 'EquipRepairSheets') is not null) then
      P_EXCEPTION(0,
                  '     (RN: %s)    .',
                  TO_CHAR(REQTCHSRV.RN));
    end if;
    /* ,      */
    if (TRUNC(DPLANDATE_FROM) = TRUNC(REQTCHSRV.DATEPRD_BEG)) then
      P_EXCEPTION(0,
                  '        %s',
                  TO_CHAR(DPLANDATE_FROM, 'dd.mm.yyyy'));
    end if;
    /*    */
    if (REQTCHSRV.STATE <> 0) then
      P_EQTCHSRV_SET_STATE(NCOMPANY => REQTCHSRV.COMPANY, NRN => REQTCHSRV.RN, NSTATE => 0, DDATE => sysdate);
    end if;
    /*       */
    NDIFF        := DPLANDATE_FROM - REQTCHSRV.DATEPRD_BEG;
    DDATEPRD_BEG := REQTCHSRV.DATEPRD_BEG + NDIFF;
    DDATEPRD_END := REQTCHSRV.DATEPRD_END + NDIFF;
    /*    */
    SNOTE := '   "' || TO_CHAR(REQTCHSRV.DATEPRD_BEG, 'dd.mm.yyyy hh24:mi:ss') || '"  "' ||
             TO_CHAR(DDATEPRD_BEG, 'dd.mm.yyyy hh24:mi:ss') || '"     "' ||
             TO_CHAR(RDSCMMLH.RQ_DATE, 'dd.mm.yyyy hh24:mi:ss') || '" (RN: ' || TO_CHAR(RDSCMMLH.RN) ||
             ', : ' || RDSCMMLH.RQ_AUTHID || ').';
    /*    */
    update EQTCHSRV T
       set T.DATEPRD_BEG = DDATEPRD_BEG,
           T.DATEPRD_END = DDATEPRD_END,
           T.NOTE        = SNOTE
     where T.RN = REQTCHSRV.RN;
    /*   */
    P_EQTCHSRV_MOVE_WORK(NCOMPANY         => REQTCHSRV.COMPANY,
                         NRN              => REQTCHSRV.RN,
                         NDUP_RN          => null,
                         DDATEPRD_BEG     => DDATEPRD_BEG,
                         DOLD_DATEPRD_BEG => REQTCHSRV.DATEPRD_BEG,
                         DDATEPRD_END     => DDATEPRD_END,
                         NPERIOD          => null,
                         NMODE            => 1);
    /*    */
    if (REQTCHSRV.STATE <> 0) then
      P_EQTCHSRV_SET_STATE(NCOMPANY => REQTCHSRV.COMPANY,
                           NRN      => REQTCHSRV.RN,
                           NSTATE   => REQTCHSRV.STATE,
                           DDATE    => sysdate);
    end if;
  end EQCONFIG_THOBJ_CHNG_EQTCHSRV;
  
  /*       */
  procedure EQCONFIG_THOBJ_MAKE_EQRPSHEET
  (
    NEQCONFIG               in number,                             -- .   
    SACATALOG               in varchar2,                           --   
    SEQTECSRVKIND           in varchar2,                           --  
    DPLANDATE_FROM          in date,                               --    
    NIDENT                  out number                             --    

  )
  is
    NCOMPANY                PKG_STD.TREF := GET_SESSION_COMPANY(); -- .  
    NCRN                    PKG_STD.TREF;                          -- .    
    SJURPERSONS             PKG_STD.TSTRING;                       --    
    SCURRENCY               PKG_STD.TSTRING;                       --  
    SDOCTYPES               PKG_STD.TSTRING;                       --   
    SPREF                   PKG_STD.TSTRING;                       --  
    SNUMB                   PKG_STD.TSTRING;                       --  
    NEQRPSHEET              PKG_STD.TREF;                          -- .       
  begin
    /*      */
    begin
      select JP.CODE
        into SJURPERSONS
        from EQCONFIG   T,
             JURPERSONS JP
       where T.RN = NEQCONFIG
         and T.JUR_PERS = JP.RN;
    exception
      when NO_DATA_FOUND then
        PKG_MSG.RECORD_NOT_FOUND(NFLAG_SMART => 0, NDOCUMENT => NEQCONFIG, SUNIT_TABLE => 'EquipConfiguration');
    end;
    /*    -   */
    SCURRENCY := GET_OPTIONS_STR(SCODE => 'Equip_RepairSheets_Currency');
    /*    -   */
    SDOCTYPES := GET_OPTIONS_STR(SCODE => 'Equip_RepairSheets_DocType');
    /*    -   */
    SPREF := GET_OPTIONS_STR(SCODE => 'Equip_RepairSheets_DocPref');
    /*     */
    P_EQRPSHEETS_GETNEXTNUMB(NCOMPANY => NCOMPANY, SPREF => SPREF, SDOCTYPES => SDOCTYPES, SNUMB => SNUMB);
    /*    */
    FIND_ACATALOG_NAME(NFLAG_SMART => 0,
                       NCOMPANY    => NCOMPANY,
                       NVERSION    => null,
                       SUNITCODE   => 'EquipRepairSheets',
                       SNAME       => SACATALOG,
                       NRN         => NCRN);
    /*   */
    P_EQRPSHEETS_MAKE_EQRPSHEET(NCOMPANY       => NCOMPANY,
                                NCRN           => NCRN,
                                SDOCTYPES      => SDOCTYPES,
                                SPREF          => SPREF,
                                SNUMB          => SNUMB,
                                DDOCDATE       => sysdate,
                                SJURPERSONS    => SJURPERSONS,
                                DPLANDATE_FROM => DPLANDATE_FROM,
                                DPLANDATE_TO   => DPLANDATE_FROM,
                                SCURRENCY      => SCURRENCY,
                                NCOURSE        => 1,
                                SEQTECSRVKIND  => SEQTECSRVKIND,
                                NPR_OBJ        => null,
                                NTECH_OBJ      => NEQCONFIG,
                                STECH_SRV_DIV  => null,
                                SRESP_DIV      => null,
                                SPERF_DIV      => null,
                                SPERFORM_AGN   => null,
                                SLEVEL         => null,
                                SEQOBJKIND     => null,
                                NRN            => NEQRPSHEET);
    /*     */
    EQCONFIG_THOBJ_SELECT_EQRPSHT(NEQRPSHEETS => NEQRPSHEET, NIDENT => NIDENT);
  end EQCONFIG_THOBJ_MAKE_EQRPSHEET;
  
end UDO_PKG_EQUIPTCF;
/
